/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.impl;

import com.inchron.realtime.root.Referrable;
import com.inchron.realtime.root.RootPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Referrable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.impl.ReferrableImpl#getIntrinsicId <em>Intrinsic Id</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ReferrableImpl extends MinimalEObjectImpl.Container implements Referrable {
	/**
	 * The default value of the '{@link #getIntrinsicId() <em>Intrinsic Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntrinsicId()
	 * @generated
	 * @ordered
	 */
	protected static final String INTRINSIC_ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIntrinsicId() <em>Intrinsic Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntrinsicId()
	 * @generated
	 * @ordered
	 */
	protected String intrinsicId = INTRINSIC_ID_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferrableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RootPackage.Literals.REFERRABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getIntrinsicId() {
		return intrinsicId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIntrinsicId(String newIntrinsicId) {
		String oldIntrinsicId = intrinsicId;
		intrinsicId = newIntrinsicId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RootPackage.REFERRABLE__INTRINSIC_ID, oldIntrinsicId, intrinsicId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RootPackage.REFERRABLE__INTRINSIC_ID:
				return getIntrinsicId();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RootPackage.REFERRABLE__INTRINSIC_ID:
				setIntrinsicId((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RootPackage.REFERRABLE__INTRINSIC_ID:
				setIntrinsicId(INTRINSIC_ID_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RootPackage.REFERRABLE__INTRINSIC_ID:
				return INTRINSIC_ID_EDEFAULT == null ? intrinsicId != null : !INTRINSIC_ID_EDEFAULT.equals(intrinsicId);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (intrinsicId: ");
		result.append(intrinsicId);
		result.append(')');
		return result.toString();
	}

} //ReferrableImpl
