/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Activation Connection</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ActivationConnection#getActivators <em>Activators</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ActivationConnection#isAndSemantic <em>And Semantic</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getActivationConnection()
 * @model
 * @generated
 */
public interface ActivationConnection extends Connection {
	/**
	 * Returns the value of the '<em><b>Activators</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ActivationItem}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.ActivationItem#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activators</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activators</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationConnection_Activators()
	 * @see com.inchron.realtime.root.model.ActivationItem#getConnection
	 * @model opposite="connection" required="true"
	 * @generated
	 */
	EList<ActivationItem> getActivators();

	/**
	 * Returns the value of the '<em><b>And Semantic</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>And Semantic</em>' attribute.
	 * @see #setAndSemantic(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationConnection_AndSemantic()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isAndSemantic();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationConnection#isAndSemantic <em>And Semantic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>And Semantic</em>' attribute.
	 * @see #isAndSemantic()
	 * @generated
	 */
	void setAndSemantic(boolean value);

} // ActivationConnection
