/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Compiler Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompiler <em>Is Target Compiler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompilerOverrideValues <em>Is Target Compiler Override Values</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#getVersion <em>Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#getPath <em>Path</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CompilerSettings#getArgs <em>Args</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings()
 * @model
 * @generated
 */
public interface CompilerSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Is Target Compiler</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Target Compiler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Target Compiler</em>' attribute.
	 * @see #setIsTargetCompiler(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_IsTargetCompiler()
	 * @model default="false"
	 * @generated
	 */
	boolean isIsTargetCompiler();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompiler <em>Is Target Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Target Compiler</em>' attribute.
	 * @see #isIsTargetCompiler()
	 * @generated
	 */
	void setIsTargetCompiler(boolean value);

	/**
	 * Returns the value of the '<em><b>Is Target Compiler Override Values</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Target Compiler Override Values</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Target Compiler Override Values</em>' attribute.
	 * @see #setIsTargetCompilerOverrideValues(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_IsTargetCompilerOverrideValues()
	 * @model default="false"
	 * @generated
	 */
	boolean isIsTargetCompilerOverrideValues();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompilerOverrideValues <em>Is Target Compiler Override Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Target Compiler Override Values</em>' attribute.
	 * @see #isIsTargetCompilerOverrideValues()
	 * @generated
	 */
	void setIsTargetCompilerOverrideValues(boolean value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_Type()
	 * @model
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Version</em>' attribute.
	 * @see #setVersion(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_Version()
	 * @model
	 * @generated
	 */
	String getVersion();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#getVersion <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Version</em>' attribute.
	 * @see #getVersion()
	 * @generated
	 */
	void setVersion(String value);

	/**
	 * Returns the value of the '<em><b>Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Path</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Path</em>' attribute.
	 * @see #setPath(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_Path()
	 * @model
	 * @generated
	 */
	String getPath();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#getPath <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Path</em>' attribute.
	 * @see #getPath()
	 * @generated
	 */
	void setPath(String value);

	/**
	 * Returns the value of the '<em><b>Args</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Args</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Args</em>' attribute.
	 * @see #setArgs(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCompilerSettings_Args()
	 * @model
	 * @generated
	 */
	String getArgs();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CompilerSettings#getArgs <em>Args</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Args</em>' attribute.
	 * @see #getArgs()
	 * @generated
	 */
	void setArgs(String value);

} // CompilerSettings
