/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Flow Edge</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowEdge#getStimulus <em>Stimulus</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowEdge#getResponse <em>Response</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowEdge()
 * @model
 * @generated
 */
public interface DataFlowEdge extends EObject {
	/**
	 * Returns the value of the '<em><b>Stimulus</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stimulus</em>' reference.
	 * @see #setStimulus(VariableAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowEdge_Stimulus()
	 * @model required="true"
	 * @generated
	 */
	VariableAccess getStimulus();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowEdge#getStimulus <em>Stimulus</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stimulus</em>' reference.
	 * @see #getStimulus()
	 * @generated
	 */
	void setStimulus(VariableAccess value);

	/**
	 * Returns the value of the '<em><b>Response</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Response</em>' reference.
	 * @see #setResponse(VariableAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowEdge_Response()
	 * @model required="true"
	 * @generated
	 */
	VariableAccess getResponse();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowEdge#getResponse <em>Response</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Response</em>' reference.
	 * @see #getResponse()
	 * @generated
	 */
	void setResponse(VariableAccess value);

} // DataFlowEdge
