/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Function Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.FunctionCall#getFunction <em>Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.FunctionCall#getGuards <em>Guards</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.FunctionCall#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.FunctionCall#getEventConjunctionOperator <em>Event Conjunction Operator</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getFunctionCall()
 * @model
 * @generated
 */
public interface FunctionCall extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Function</em>' reference.
	 * @see #setFunction(Function)
	 * @see com.inchron.realtime.root.model.ModelPackage#getFunctionCall_Function()
	 * @model required="true"
	 * @generated
	 */
	Function getFunction();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.FunctionCall#getFunction <em>Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Function</em>' reference.
	 * @see #getFunction()
	 * @generated
	 */
	void setFunction(Function value);

	/**
	 * Returns the value of the '<em><b>Guards</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.SetGuard}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.SetGuard#getFunctionCall <em>Function Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Guards</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getFunctionCall_Guards()
	 * @see com.inchron.realtime.root.model.SetGuard#getFunctionCall
	 * @model opposite="functionCall"
	 * @generated
	 */
	EList<SetGuard> getGuards();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Event}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getFunctionCall_Events()
	 * @model
	 * @generated
	 */
	EList<Event> getEvents();

	/**
	 * Returns the value of the '<em><b>Event Conjunction Operator</b></em>' attribute.
	 * The default value is <code>"OR"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.EventConjunctionOperatorType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Conjunction Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Conjunction Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.EventConjunctionOperatorType
	 * @see #setEventConjunctionOperator(EventConjunctionOperatorType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getFunctionCall_EventConjunctionOperator()
	 * @model default="OR"
	 * @generated
	 */
	EventConjunctionOperatorType getEventConjunctionOperator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.FunctionCall#getEventConjunctionOperator <em>Event Conjunction Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Conjunction Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.EventConjunctionOperatorType
	 * @see #getEventConjunctionOperator()
	 * @generated
	 */
	void setEventConjunctionOperator(EventConjunctionOperatorType value);

} // FunctionCall
