/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rtos Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getName <em>Name</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#isReloadRtosModel <em>Reload Rtos Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getVersion <em>Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getRtosProperties <em>Rtos Properties</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getReturnType <em>Return Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getLibrary <em>Library</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getHeader <em>Header</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getNameSpace <em>Name Space</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getUserHeader <em>User Header</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getStateNames <em>State Names</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getApiPrefix <em>Api Prefix</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosModel#getRtosApiType <em>Rtos Api Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel()
 * @model
 * @generated
 */
public interface RtosModel extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Reload Rtos Model</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reload Rtos Model</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reload Rtos Model</em>' attribute.
	 * @see #setReloadRtosModel(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_ReloadRtosModel()
	 * @model default="false"
	 * @generated
	 */
	boolean isReloadRtosModel();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#isReloadRtosModel <em>Reload Rtos Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reload Rtos Model</em>' attribute.
	 * @see #isReloadRtosModel()
	 * @generated
	 */
	void setReloadRtosModel(boolean value);

	/**
	 * Returns the value of the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Version</em>' attribute.
	 * @see #setVersion(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_Version()
	 * @model
	 * @generated
	 */
	String getVersion();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getVersion <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Version</em>' attribute.
	 * @see #getVersion()
	 * @generated
	 */
	void setVersion(String value);

	/**
	 * Returns the value of the '<em><b>Rtos Properties</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rtos Properties</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rtos Properties</em>' attribute.
	 * @see #setRtosProperties(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_RtosProperties()
	 * @model default="0"
	 * @generated
	 */
	int getRtosProperties();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getRtosProperties <em>Rtos Properties</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rtos Properties</em>' attribute.
	 * @see #getRtosProperties()
	 * @generated
	 */
	void setRtosProperties(int value);

	/**
	 * Returns the value of the '<em><b>Return Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Return Type</em>' attribute.
	 * @see #setReturnType(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_ReturnType()
	 * @model
	 * @generated
	 */
	String getReturnType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getReturnType <em>Return Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Return Type</em>' attribute.
	 * @see #getReturnType()
	 * @generated
	 */
	void setReturnType(String value);

	/**
	 * Returns the value of the '<em><b>Library</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Library</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Library</em>' attribute.
	 * @see #setLibrary(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_Library()
	 * @model
	 * @generated
	 */
	String getLibrary();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getLibrary <em>Library</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Library</em>' attribute.
	 * @see #getLibrary()
	 * @generated
	 */
	void setLibrary(String value);

	/**
	 * Returns the value of the '<em><b>Header</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Header</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Header</em>' attribute.
	 * @see #setHeader(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_Header()
	 * @model
	 * @generated
	 */
	String getHeader();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getHeader <em>Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Header</em>' attribute.
	 * @see #getHeader()
	 * @generated
	 */
	void setHeader(String value);

	/**
	 * Returns the value of the '<em><b>Name Space</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name Space</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name Space</em>' attribute.
	 * @see #setNameSpace(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_NameSpace()
	 * @model
	 * @generated
	 */
	String getNameSpace();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getNameSpace <em>Name Space</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name Space</em>' attribute.
	 * @see #getNameSpace()
	 * @generated
	 */
	void setNameSpace(String value);

	/**
	 * Returns the value of the '<em><b>User Header</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>User Header</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>User Header</em>' attribute.
	 * @see #setUserHeader(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_UserHeader()
	 * @model
	 * @generated
	 */
	String getUserHeader();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getUserHeader <em>User Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>User Header</em>' attribute.
	 * @see #getUserHeader()
	 * @generated
	 */
	void setUserHeader(String value);

	/**
	 * Returns the value of the '<em><b>State Names</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State Names</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>State Names</em>' attribute list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_StateNames()
	 * @model
	 * @generated
	 */
	EList<String> getStateNames();

	/**
	 * Returns the value of the '<em><b>Api Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Api Prefix</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Api Prefix</em>' attribute.
	 * @see #setApiPrefix(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_ApiPrefix()
	 * @model
	 * @generated
	 */
	String getApiPrefix();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getApiPrefix <em>Api Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Api Prefix</em>' attribute.
	 * @see #getApiPrefix()
	 * @generated
	 */
	void setApiPrefix(String value);

	/**
	 * Returns the value of the '<em><b>Rtos Api Type</b></em>' attribute.
	 * The default value is <code>"None"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.RtosApiType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rtos Api Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rtos Api Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.RtosApiType
	 * @see #setRtosApiType(RtosApiType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosModel_RtosApiType()
	 * @model default="None"
	 * @generated
	 */
	RtosApiType getRtosApiType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.RtosModel#getRtosApiType <em>Rtos Api Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rtos Api Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.RtosApiType
	 * @see #getRtosApiType()
	 * @generated
	 */
	void setRtosApiType(RtosApiType value);

} // RtosModel
