/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Schedulable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Schedulable#getCpuCores <em>Cpu Cores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Schedulable#getPriority <em>Priority</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulable()
 * @model abstract="true"
 * @generated
 */
public interface Schedulable extends ModelObject, TraceObject {
	/**
	 * Returns the value of the '<em><b>Cpu Cores</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.CpuCore}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu Cores</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu Cores</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulable_CpuCores()
	 * @model
	 * @generated
	 */
	EList<CpuCore> getCpuCores();

	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulable_Priority()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getPriority();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Schedulable#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);

} // Schedulable
