/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Set Guard</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.SetGuard#getFunctionCall <em>Function Call</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSetGuard()
 * @model
 * @generated
 */
public interface SetGuard extends ActivationAction {
	/**
	 * Returns the value of the '<em><b>Function Call</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.FunctionCall#getGuards <em>Guards</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Function Call</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Function Call</em>' reference.
	 * @see #setFunctionCall(FunctionCall)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSetGuard_FunctionCall()
	 * @see com.inchron.realtime.root.model.FunctionCall#getGuards
	 * @model opposite="guards" required="true"
	 * @generated
	 */
	FunctionCall getFunctionCall();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SetGuard#getFunctionCall <em>Function Call</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Function Call</em>' reference.
	 * @see #getFunctionCall()
	 * @generated
	 */
	void setFunctionCall(FunctionCall value);

} // SetGuard
