/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Spinlock Operation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.SpinlockOperation#getOperation <em>Operation</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SpinlockOperation#getSpinlock <em>Spinlock</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSpinlockOperation()
 * @model
 * @generated
 */
public interface SpinlockOperation extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Operation</b></em>' attribute.
	 * The default value is <code>"Acquire"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.SpinlockOperationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operation</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operation</em>' attribute.
	 * @see com.inchron.realtime.root.model.SpinlockOperationType
	 * @see #setOperation(SpinlockOperationType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSpinlockOperation_Operation()
	 * @model default="Acquire"
	 * @generated
	 */
	SpinlockOperationType getOperation();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SpinlockOperation#getOperation <em>Operation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operation</em>' attribute.
	 * @see com.inchron.realtime.root.model.SpinlockOperationType
	 * @see #getOperation()
	 * @generated
	 */
	void setOperation(SpinlockOperationType value);

	/**
	 * Returns the value of the '<em><b>Spinlock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spinlock</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spinlock</em>' reference.
	 * @see #setSpinlock(Spinlock)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSpinlockOperation_Spinlock()
	 * @model
	 * @generated
	 */
	Spinlock getSpinlock();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SpinlockOperation#getSpinlock <em>Spinlock</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Spinlock</em>' reference.
	 * @see #getSpinlock()
	 * @generated
	 */
	void setSpinlock(Spinlock value);

} // SpinlockOperation
