/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Time Interval</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.TimeInterval#getLowerLimit <em>Lower Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeInterval#getUpperLimit <em>Upper Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeInterval#isLowerLimitIncluded <em>Lower Limit Included</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeInterval#isUpperLimitIncluded <em>Upper Limit Included</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getTimeInterval()
 * @model
 * @generated
 */
public interface TimeInterval extends EObject {
	/**
	 * Returns the value of the '<em><b>Lower Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lower Limit</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lower Limit</em>' containment reference.
	 * @see #setLowerLimit(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeInterval_LowerLimit()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getLowerLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeInterval#getLowerLimit <em>Lower Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lower Limit</em>' containment reference.
	 * @see #getLowerLimit()
	 * @generated
	 */
	void setLowerLimit(Time value);

	/**
	 * Returns the value of the '<em><b>Upper Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Upper Limit</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Upper Limit</em>' containment reference.
	 * @see #setUpperLimit(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeInterval_UpperLimit()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getUpperLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeInterval#getUpperLimit <em>Upper Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Upper Limit</em>' containment reference.
	 * @see #getUpperLimit()
	 * @generated
	 */
	void setUpperLimit(Time value);

	/**
	 * Returns the value of the '<em><b>Lower Limit Included</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lower Limit Included</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lower Limit Included</em>' attribute.
	 * @see #setLowerLimitIncluded(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeInterval_LowerLimitIncluded()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isLowerLimitIncluded();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeInterval#isLowerLimitIncluded <em>Lower Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lower Limit Included</em>' attribute.
	 * @see #isLowerLimitIncluded()
	 * @generated
	 */
	void setLowerLimitIncluded(boolean value);

	/**
	 * Returns the value of the '<em><b>Upper Limit Included</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Upper Limit Included</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Upper Limit Included</em>' attribute.
	 * @see #setUpperLimitIncluded(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeInterval_UpperLimitIncluded()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isUpperLimitIncluded();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeInterval#isUpperLimitIncluded <em>Upper Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Upper Limit Included</em>' attribute.
	 * @see #isUpperLimitIncluded()
	 * @generated
	 */
	void setUpperLimitIncluded(boolean value);

} // TimeInterval
