/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Trace Event Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelPackage#getTraceEventType()
 * @model
 * @generated
 */
public enum TraceEventType implements Enumerator {
	/**
	 * The '<em><b>Activate</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ACTIVATE_VALUE
	 * @generated
	 * @ordered
	 */
	ACTIVATE(0, "Activate", "Activate"),

	/**
	 * The '<em><b>Start</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #START_VALUE
	 * @generated
	 * @ordered
	 */
	START(1, "Start", "Start"),

	/**
	 * The '<em><b>Terminate</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TERMINATE_VALUE
	 * @generated
	 * @ordered
	 */
	TERMINATE(2, "Terminate", "Terminate"),

	/**
	 * The '<em><b>Block</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BLOCK_VALUE
	 * @generated
	 * @ordered
	 */
	BLOCK(3, "Block", "Block"),

	/**
	 * The '<em><b>Release</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #RELEASE_VALUE
	 * @generated
	 * @ordered
	 */
	RELEASE(4, "Release", "Release"),

	/**
	 * The '<em><b>Restart</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #RESTART_VALUE
	 * @generated
	 * @ordered
	 */
	RESTART(5, "Restart", "Restart"),

	/**
	 * The '<em><b>Entry</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ENTRY_VALUE
	 * @generated
	 * @ordered
	 */
	ENTRY(6, "Entry", "Entry"),

	/**
	 * The '<em><b>Exit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXIT_VALUE
	 * @generated
	 * @ordered
	 */
	EXIT(7, "Exit", "Exit"),

	/**
	 * The '<em><b>User Code</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #USER_CODE_VALUE
	 * @generated
	 * @ordered
	 */
	USER_CODE(8, "UserCode", "UserCode"),

	/**
	 * The '<em><b>User Code Param</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #USER_CODE_PARAM_VALUE
	 * @generated
	 * @ordered
	 */
	USER_CODE_PARAM(9, "UserCodeParam", "UserCodeParam"),

	/**
	 * The '<em><b>Event Chain</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EVENT_CHAIN_VALUE
	 * @generated
	 * @ordered
	 */
	EVENT_CHAIN(10, "EventChain", "EventChain"),

	/**
	 * The '<em><b>Data Flow Chain</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATA_FLOW_CHAIN_VALUE
	 * @generated
	 * @ordered
	 */
	DATA_FLOW_CHAIN(11, "DataFlowChain", "DataFlowChain"),

	/**
	 * The '<em><b>Activation Flow Chain</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ACTIVATION_FLOW_CHAIN_VALUE
	 * @generated
	 * @ordered
	 */
	ACTIVATION_FLOW_CHAIN(12, "ActivationFlowChain", "ActivationFlowChain"),

	/**
	 * The '<em><b>Frame Begin</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FRAME_BEGIN_VALUE
	 * @generated
	 * @ordered
	 */
	FRAME_BEGIN(13, "FrameBegin", "FrameBegin"),

	/**
	 * The '<em><b>Frame End</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FRAME_END_VALUE
	 * @generated
	 * @ordered
	 */
	FRAME_END(14, "FrameEnd", "FrameEnd"),

	/**
	 * The '<em><b>Frame Abort</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FRAME_ABORT_VALUE
	 * @generated
	 * @ordered
	 */
	FRAME_ABORT(15, "FrameAbort", "FrameAbort"),

	/**
	 * The '<em><b>Cycle Start</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CYCLE_START_VALUE
	 * @generated
	 * @ordered
	 */
	CYCLE_START(16, "CycleStart", "CycleStart"),

	/**
	 * The '<em><b>Dynamic Segment</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DYNAMIC_SEGMENT_VALUE
	 * @generated
	 * @ordered
	 */
	DYNAMIC_SEGMENT(17, "DynamicSegment", "DynamicSegment"),

	/**
	 * The '<em><b>Network Idle Time</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NETWORK_IDLE_TIME_VALUE
	 * @generated
	 * @ordered
	 */
	NETWORK_IDLE_TIME(18, "NetworkIdleTime", "NetworkIdleTime"),

	/**
	 * The '<em><b>Transfer Counter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TRANSFER_COUNTER_VALUE
	 * @generated
	 * @ordered
	 */
	TRANSFER_COUNTER(19, "TransferCounter", "TransferCounter"),

	/**
	 * The '<em><b>Frame Drop</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FRAME_DROP_VALUE
	 * @generated
	 * @ordered
	 */
	FRAME_DROP(20, "FrameDrop", "FrameDrop"),

	/**
	 * The '<em><b>Timer Create</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_CREATE_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_CREATE(21, "TimerCreate", "TimerCreate"),

	/**
	 * The '<em><b>Timer Delete</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_DELETE_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_DELETE(22, "TimerDelete", "TimerDelete"),

	/**
	 * The '<em><b>Timer Start</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_START_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_START(23, "TimerStart", "TimerStart"),

	/**
	 * The '<em><b>Timer Stop</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_STOP_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_STOP(24, "TimerStop", "TimerStop"),

	/**
	 * The '<em><b>Timer Expire</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXPIRE_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_EXPIRE(25, "TimerExpire", "TimerExpire"),

	/**
	 * The '<em><b>Timer Exp Rest</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXP_REST_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_EXP_REST(26, "TimerExpRest", "TimerExpRest"),

	/**
	 * The '<em><b>Timer End Mark</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_END_MARK_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_END_MARK(27, "TimerEndMark", "TimerEndMark");

	/**
	 * The '<em><b>Activate</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Activate</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ACTIVATE
	 * @model name="Activate"
	 * @generated
	 * @ordered
	 */
	public static final int ACTIVATE_VALUE = 0;

	/**
	 * The '<em><b>Start</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Start</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #START
	 * @model name="Start"
	 * @generated
	 * @ordered
	 */
	public static final int START_VALUE = 1;

	/**
	 * The '<em><b>Terminate</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Terminate</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TERMINATE
	 * @model name="Terminate"
	 * @generated
	 * @ordered
	 */
	public static final int TERMINATE_VALUE = 2;

	/**
	 * The '<em><b>Block</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Block</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BLOCK
	 * @model name="Block"
	 * @generated
	 * @ordered
	 */
	public static final int BLOCK_VALUE = 3;

	/**
	 * The '<em><b>Release</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Release</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #RELEASE
	 * @model name="Release"
	 * @generated
	 * @ordered
	 */
	public static final int RELEASE_VALUE = 4;

	/**
	 * The '<em><b>Restart</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Restart</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #RESTART
	 * @model name="Restart"
	 * @generated
	 * @ordered
	 */
	public static final int RESTART_VALUE = 5;

	/**
	 * The '<em><b>Entry</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Entry</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ENTRY
	 * @model name="Entry"
	 * @generated
	 * @ordered
	 */
	public static final int ENTRY_VALUE = 6;

	/**
	 * The '<em><b>Exit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Exit</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXIT
	 * @model name="Exit"
	 * @generated
	 * @ordered
	 */
	public static final int EXIT_VALUE = 7;

	/**
	 * The '<em><b>User Code</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>User Code</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #USER_CODE
	 * @model name="UserCode"
	 * @generated
	 * @ordered
	 */
	public static final int USER_CODE_VALUE = 8;

	/**
	 * The '<em><b>User Code Param</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>User Code Param</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #USER_CODE_PARAM
	 * @model name="UserCodeParam"
	 * @generated
	 * @ordered
	 */
	public static final int USER_CODE_PARAM_VALUE = 9;

	/**
	 * The '<em><b>Event Chain</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Event Chain</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EVENT_CHAIN
	 * @model name="EventChain"
	 * @generated
	 * @ordered
	 */
	public static final int EVENT_CHAIN_VALUE = 10;

	/**
	 * The '<em><b>Data Flow Chain</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Data Flow Chain</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATA_FLOW_CHAIN
	 * @model name="DataFlowChain"
	 * @generated
	 * @ordered
	 */
	public static final int DATA_FLOW_CHAIN_VALUE = 11;

	/**
	 * The '<em><b>Activation Flow Chain</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Activation Flow Chain</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ACTIVATION_FLOW_CHAIN
	 * @model name="ActivationFlowChain"
	 * @generated
	 * @ordered
	 */
	public static final int ACTIVATION_FLOW_CHAIN_VALUE = 12;

	/**
	 * The '<em><b>Frame Begin</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Frame Begin</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FRAME_BEGIN
	 * @model name="FrameBegin"
	 * @generated
	 * @ordered
	 */
	public static final int FRAME_BEGIN_VALUE = 13;

	/**
	 * The '<em><b>Frame End</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Frame End</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FRAME_END
	 * @model name="FrameEnd"
	 * @generated
	 * @ordered
	 */
	public static final int FRAME_END_VALUE = 14;

	/**
	 * The '<em><b>Frame Abort</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Frame Abort</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FRAME_ABORT
	 * @model name="FrameAbort"
	 * @generated
	 * @ordered
	 */
	public static final int FRAME_ABORT_VALUE = 15;

	/**
	 * The '<em><b>Cycle Start</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Cycle Start</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CYCLE_START
	 * @model name="CycleStart"
	 * @generated
	 * @ordered
	 */
	public static final int CYCLE_START_VALUE = 16;

	/**
	 * The '<em><b>Dynamic Segment</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Dynamic Segment</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DYNAMIC_SEGMENT
	 * @model name="DynamicSegment"
	 * @generated
	 * @ordered
	 */
	public static final int DYNAMIC_SEGMENT_VALUE = 17;

	/**
	 * The '<em><b>Network Idle Time</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Network Idle Time</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NETWORK_IDLE_TIME
	 * @model name="NetworkIdleTime"
	 * @generated
	 * @ordered
	 */
	public static final int NETWORK_IDLE_TIME_VALUE = 18;

	/**
	 * The '<em><b>Transfer Counter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Transfer Counter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TRANSFER_COUNTER
	 * @model name="TransferCounter"
	 * @generated
	 * @ordered
	 */
	public static final int TRANSFER_COUNTER_VALUE = 19;

	/**
	 * The '<em><b>Frame Drop</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Frame Drop</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FRAME_DROP
	 * @model name="FrameDrop"
	 * @generated
	 * @ordered
	 */
	public static final int FRAME_DROP_VALUE = 20;

	/**
	 * The '<em><b>Timer Create</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Create</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_CREATE
	 * @model name="TimerCreate"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_CREATE_VALUE = 21;

	/**
	 * The '<em><b>Timer Delete</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Delete</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_DELETE
	 * @model name="TimerDelete"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_DELETE_VALUE = 22;

	/**
	 * The '<em><b>Timer Start</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Start</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_START
	 * @model name="TimerStart"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_START_VALUE = 23;

	/**
	 * The '<em><b>Timer Stop</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Stop</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_STOP
	 * @model name="TimerStop"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_STOP_VALUE = 24;

	/**
	 * The '<em><b>Timer Expire</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Expire</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXPIRE
	 * @model name="TimerExpire"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_EXPIRE_VALUE = 25;

	/**
	 * The '<em><b>Timer Exp Rest</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Exp Rest</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXP_REST
	 * @model name="TimerExpRest"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_EXP_REST_VALUE = 26;

	/**
	 * The '<em><b>Timer End Mark</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer End Mark</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_END_MARK
	 * @model name="TimerEndMark"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_END_MARK_VALUE = 27;

	/**
	 * An array of all the '<em><b>Trace Event Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TraceEventType[] VALUES_ARRAY =
		new TraceEventType[] {
			ACTIVATE,
			START,
			TERMINATE,
			BLOCK,
			RELEASE,
			RESTART,
			ENTRY,
			EXIT,
			USER_CODE,
			USER_CODE_PARAM,
			EVENT_CHAIN,
			DATA_FLOW_CHAIN,
			ACTIVATION_FLOW_CHAIN,
			FRAME_BEGIN,
			FRAME_END,
			FRAME_ABORT,
			CYCLE_START,
			DYNAMIC_SEGMENT,
			NETWORK_IDLE_TIME,
			TRANSFER_COUNTER,
			FRAME_DROP,
			TIMER_CREATE,
			TIMER_DELETE,
			TIMER_START,
			TIMER_STOP,
			TIMER_EXPIRE,
			TIMER_EXP_REST,
			TIMER_END_MARK,
		};

	/**
	 * A public read-only list of all the '<em><b>Trace Event Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<TraceEventType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Trace Event Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static TraceEventType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TraceEventType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Trace Event Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static TraceEventType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TraceEventType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Trace Event Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static TraceEventType get(int value) {
		switch (value) {
			case ACTIVATE_VALUE: return ACTIVATE;
			case START_VALUE: return START;
			case TERMINATE_VALUE: return TERMINATE;
			case BLOCK_VALUE: return BLOCK;
			case RELEASE_VALUE: return RELEASE;
			case RESTART_VALUE: return RESTART;
			case ENTRY_VALUE: return ENTRY;
			case EXIT_VALUE: return EXIT;
			case USER_CODE_VALUE: return USER_CODE;
			case USER_CODE_PARAM_VALUE: return USER_CODE_PARAM;
			case EVENT_CHAIN_VALUE: return EVENT_CHAIN;
			case DATA_FLOW_CHAIN_VALUE: return DATA_FLOW_CHAIN;
			case ACTIVATION_FLOW_CHAIN_VALUE: return ACTIVATION_FLOW_CHAIN;
			case FRAME_BEGIN_VALUE: return FRAME_BEGIN;
			case FRAME_END_VALUE: return FRAME_END;
			case FRAME_ABORT_VALUE: return FRAME_ABORT;
			case CYCLE_START_VALUE: return CYCLE_START;
			case DYNAMIC_SEGMENT_VALUE: return DYNAMIC_SEGMENT;
			case NETWORK_IDLE_TIME_VALUE: return NETWORK_IDLE_TIME;
			case TRANSFER_COUNTER_VALUE: return TRANSFER_COUNTER;
			case FRAME_DROP_VALUE: return FRAME_DROP;
			case TIMER_CREATE_VALUE: return TIMER_CREATE;
			case TIMER_DELETE_VALUE: return TIMER_DELETE;
			case TIMER_START_VALUE: return TIMER_START;
			case TIMER_STOP_VALUE: return TIMER_STOP;
			case TIMER_EXPIRE_VALUE: return TIMER_EXPIRE;
			case TIMER_EXP_REST_VALUE: return TIMER_EXP_REST;
			case TIMER_END_MARK_VALUE: return TIMER_END_MARK;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TraceEventType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //TraceEventType
