/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>User Code Event Chain</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.UserCodeEventChain#getSteps <em>Steps</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getUserCodeEventChain()
 * @model
 * @generated
 */
public interface UserCodeEventChain extends EventChain {
	/**
	 * Returns the value of the '<em><b>Steps</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.UserCodeEventChainStep}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Steps</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Steps</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getUserCodeEventChain_Steps()
	 * @model containment="true"
	 * @generated
	 */
	EList<UserCodeEventChainStep> getSteps();

} // UserCodeEventChain
