/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Alarm</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAction <em>Action</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAppMode <em>Autostart App Mode</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartCycleTime <em>Autostart Cycle Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAlarmTime <em>Autostart Alarm Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#isAutostart <em>Autostart</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarm#getCounter <em>Counter</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm()
 * @model
 * @generated
 */
public interface OsAlarm extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Action</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Action</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Action</em>' containment reference.
	 * @see #setAction(OsAlarmAction)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_Action()
	 * @model containment="true"
	 * @generated
	 */
	OsAlarmAction getAction();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAction <em>Action</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Action</em>' containment reference.
	 * @see #getAction()
	 * @generated
	 */
	void setAction(OsAlarmAction value);

	/**
	 * Returns the value of the '<em><b>Autostart App Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Autostart App Mode</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Autostart App Mode</em>' attribute.
	 * @see #setAutostartAppMode(String)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_AutostartAppMode()
	 * @model required="true"
	 * @generated
	 */
	String getAutostartAppMode();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAppMode <em>Autostart App Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Autostart App Mode</em>' attribute.
	 * @see #getAutostartAppMode()
	 * @generated
	 */
	void setAutostartAppMode(String value);

	/**
	 * Returns the value of the '<em><b>Autostart Cycle Time</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Autostart Cycle Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Autostart Cycle Time</em>' attribute.
	 * @see #setAutostartCycleTime(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_AutostartCycleTime()
	 * @model default="1" required="true"
	 * @generated
	 */
	long getAutostartCycleTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartCycleTime <em>Autostart Cycle Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Autostart Cycle Time</em>' attribute.
	 * @see #getAutostartCycleTime()
	 * @generated
	 */
	void setAutostartCycleTime(long value);

	/**
	 * Returns the value of the '<em><b>Autostart Alarm Time</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Autostart Alarm Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Autostart Alarm Time</em>' attribute.
	 * @see #setAutostartAlarmTime(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_AutostartAlarmTime()
	 * @model default="0" required="true"
	 * @generated
	 */
	long getAutostartAlarmTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getAutostartAlarmTime <em>Autostart Alarm Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Autostart Alarm Time</em>' attribute.
	 * @see #getAutostartAlarmTime()
	 * @generated
	 */
	void setAutostartAlarmTime(long value);

	/**
	 * Returns the value of the '<em><b>Autostart</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Autostart</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Autostart</em>' attribute.
	 * @see #setAutostart(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_Autostart()
	 * @model default="false" required="true" ordered="false"
	 * @generated
	 */
	boolean isAutostart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#isAutostart <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Autostart</em>' attribute.
	 * @see #isAutostart()
	 * @generated
	 */
	void setAutostart(boolean value);

	/**
	 * Returns the value of the '<em><b>Counter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Counter</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Counter</em>' reference.
	 * @see #setCounter(OsCounter)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarm_Counter()
	 * @model required="true"
	 * @generated
	 */
	OsCounter getCounter();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarm#getCounter <em>Counter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Counter</em>' reference.
	 * @see #getCounter()
	 * @generated
	 */
	void setCounter(OsCounter value);

} // OsAlarm
