/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getAlarms <em>Alarms</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getCounters <em>Counters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getIsrs <em>Isrs</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getResources <em>Resources</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getScheduleTables <em>Schedule Tables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getSpinlocks <em>Spinlocks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsConfig#getTasks <em>Tasks</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig()
 * @model
 * @generated
 */
public interface OsConfig extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Alarms</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsAlarm}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alarms</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alarms</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Alarms()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsAlarm> getAlarms();

	/**
	 * Returns the value of the '<em><b>Applications</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsApplication}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Applications</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Applications</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Applications()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsApplication> getApplications();

	/**
	 * Returns the value of the '<em><b>Counters</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsCounter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Counters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Counters</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Counters()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsCounter> getCounters();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsEvent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Events()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsEvent> getEvents();

	/**
	 * Returns the value of the '<em><b>Isrs</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsIsr}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Isrs</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Isrs</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Isrs()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsIsr> getIsrs();

	/**
	 * Returns the value of the '<em><b>Resources</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsResource}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resources</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resources</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Resources()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsResource> getResources();

	/**
	 * Returns the value of the '<em><b>Schedule Tables</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsScheduleTable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Schedule Tables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Schedule Tables</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_ScheduleTables()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsScheduleTable> getScheduleTables();

	/**
	 * Returns the value of the '<em><b>Spinlocks</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsSpinlock}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spinlocks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spinlocks</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Spinlocks()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsSpinlock> getSpinlocks();

	/**
	 * Returns the value of the '<em><b>Tasks</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsTask}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tasks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tasks</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsConfig_Tasks()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsTask> getTasks();

} // OsConfig
