/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.Event;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsEvent#getMask <em>Mask</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsEvent#isMaskAuto <em>Mask Auto</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsEvent()
 * @model
 * @generated
 */
public interface OsEvent extends Event {
	/**
	 * Returns the value of the '<em><b>Mask</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mask</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mask</em>' attribute.
	 * @see #setMask(int)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsEvent_Mask()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getMask();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsEvent#getMask <em>Mask</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mask</em>' attribute.
	 * @see #getMask()
	 * @generated
	 */
	void setMask(int value);

	/**
	 * Returns the value of the '<em><b>Mask Auto</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mask Auto</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mask Auto</em>' attribute.
	 * @see #setMaskAuto(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsEvent_MaskAuto()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isMaskAuto();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsEvent#isMaskAuto <em>Mask Auto</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mask Auto</em>' attribute.
	 * @see #isMaskAuto()
	 * @generated
	 */
	void setMaskAuto(boolean value);

} // OsEvent
