/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Schedule Table</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isAutostart <em>Autostart</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getCounter <em>Counter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getDuration <em>Duration</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getExpiryPoints <em>Expiry Points</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isRepeating <em>Repeating</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getStartType <em>Start Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable()
 * @model
 * @generated
 */
public interface OsScheduleTable extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Autostart</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Autostart</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Autostart</em>' attribute.
	 * @see #setAutostart(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_Autostart()
	 * @model default="true" required="true" ordered="false"
	 * @generated
	 */
	boolean isAutostart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isAutostart <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Autostart</em>' attribute.
	 * @see #isAutostart()
	 * @generated
	 */
	void setAutostart(boolean value);

	/**
	 * Returns the value of the '<em><b>Counter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Counter</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Counter</em>' reference.
	 * @see #setCounter(OsCounter)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_Counter()
	 * @model
	 * @generated
	 */
	OsCounter getCounter();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getCounter <em>Counter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Counter</em>' reference.
	 * @see #getCounter()
	 * @generated
	 */
	void setCounter(OsCounter value);

	/**
	 * Returns the value of the '<em><b>Duration</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Duration</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Duration</em>' attribute.
	 * @see #setDuration(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_Duration()
	 * @model default="1" required="true" ordered="false"
	 * @generated
	 */
	long getDuration();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getDuration <em>Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Duration</em>' attribute.
	 * @see #getDuration()
	 * @generated
	 */
	void setDuration(long value);

	/**
	 * Returns the value of the '<em><b>Expiry Points</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsExpiryPoint}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expiry Points</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expiry Points</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_ExpiryPoints()
	 * @model containment="true"
	 * @generated
	 */
	EList<OsExpiryPoint> getExpiryPoints();

	/**
	 * Returns the value of the '<em><b>Repeating</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Repeating</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Repeating</em>' attribute.
	 * @see #setRepeating(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_Repeating()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isRepeating();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#isRepeating <em>Repeating</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Repeating</em>' attribute.
	 * @see #isRepeating()
	 * @generated
	 */
	void setRepeating(boolean value);

	/**
	 * Returns the value of the '<em><b>Start Type</b></em>' attribute.
	 * The default value is <code>"Absolute"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.autosar.OsScheduleTableStartType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTableStartType
	 * @see #setStartType(OsScheduleTableStartType)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsScheduleTable_StartType()
	 * @model default="Absolute" required="true" ordered="false"
	 * @generated
	 */
	OsScheduleTableStartType getStartType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsScheduleTable#getStartType <em>Start Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsScheduleTableStartType
	 * @see #getStartType()
	 * @generated
	 */
	void setStartType(OsScheduleTableStartType value);

} // OsScheduleTable
