/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.Partition;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsAlarm;
import com.inchron.realtime.root.model.autosar.OsApplication;
import com.inchron.realtime.root.model.autosar.OsCounter;
import com.inchron.realtime.root.model.autosar.OsIsr;
import com.inchron.realtime.root.model.autosar.OsScheduleTable;
import com.inchron.realtime.root.model.autosar.OsTask;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Application</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getAlarms <em>Alarms</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getCounters <em>Counters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getCpuCore <em>Cpu Core</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getPartition <em>Partition</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getIsrs <em>Isrs</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getScheduleTables <em>Schedule Tables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#getTasks <em>Tasks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#isIsTrusted <em>Is Trusted</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsApplicationImpl#isIsTrustedWithProtection <em>Is Trusted With Protection</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsApplicationImpl extends ModelObjectImpl implements OsApplication {
	/**
	 * The cached value of the '{@link #getAlarms() <em>Alarms</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarms()
	 * @generated
	 * @ordered
	 */
	protected EList<OsAlarm> alarms;

	/**
	 * The cached value of the '{@link #getCounters() <em>Counters</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCounters()
	 * @generated
	 * @ordered
	 */
	protected EList<OsCounter> counters;

	/**
	 * The cached value of the '{@link #getCpuCore() <em>Cpu Core</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpuCore()
	 * @generated
	 * @ordered
	 */
	protected CpuCore cpuCore;

	/**
	 * The cached value of the '{@link #getPartition() <em>Partition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartition()
	 * @generated
	 * @ordered
	 */
	protected Partition partition;

	/**
	 * The cached value of the '{@link #getIsrs() <em>Isrs</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsrs()
	 * @generated
	 * @ordered
	 */
	protected EList<OsIsr> isrs;

	/**
	 * The cached value of the '{@link #getScheduleTables() <em>Schedule Tables</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScheduleTables()
	 * @generated
	 * @ordered
	 */
	protected EList<OsScheduleTable> scheduleTables;

	/**
	 * The cached value of the '{@link #getTasks() <em>Tasks</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTasks()
	 * @generated
	 * @ordered
	 */
	protected EList<OsTask> tasks;

	/**
	 * The default value of the '{@link #isIsTrusted() <em>Is Trusted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTrusted()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_TRUSTED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsTrusted() <em>Is Trusted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTrusted()
	 * @generated
	 * @ordered
	 */
	protected boolean isTrusted = IS_TRUSTED_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsTrustedWithProtection() <em>Is Trusted With Protection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTrustedWithProtection()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_TRUSTED_WITH_PROTECTION_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsTrustedWithProtection() <em>Is Trusted With Protection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTrustedWithProtection()
	 * @generated
	 * @ordered
	 */
	protected boolean isTrustedWithProtection = IS_TRUSTED_WITH_PROTECTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsApplicationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_APPLICATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsAlarm> getAlarms() {
		if (alarms == null) {
			alarms = new EObjectResolvingEList<OsAlarm>(OsAlarm.class, this, AutosarPackage.OS_APPLICATION__ALARMS);
		}
		return alarms;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsCounter> getCounters() {
		if (counters == null) {
			counters = new EObjectResolvingEList<OsCounter>(OsCounter.class, this, AutosarPackage.OS_APPLICATION__COUNTERS);
		}
		return counters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CpuCore getCpuCore() {
		if (cpuCore != null && cpuCore.eIsProxy()) {
			InternalEObject oldCpuCore = (InternalEObject)cpuCore;
			cpuCore = (CpuCore)eResolveProxy(oldCpuCore);
			if (cpuCore != oldCpuCore) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_APPLICATION__CPU_CORE, oldCpuCore, cpuCore));
			}
		}
		return cpuCore;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CpuCore basicGetCpuCore() {
		return cpuCore;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpuCore(CpuCore newCpuCore) {
		CpuCore oldCpuCore = cpuCore;
		cpuCore = newCpuCore;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_APPLICATION__CPU_CORE, oldCpuCore, cpuCore));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Partition getPartition() {
		if (partition != null && partition.eIsProxy()) {
			InternalEObject oldPartition = (InternalEObject)partition;
			partition = (Partition)eResolveProxy(oldPartition);
			if (partition != oldPartition) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_APPLICATION__PARTITION, oldPartition, partition));
			}
		}
		return partition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Partition basicGetPartition() {
		return partition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPartition(Partition newPartition) {
		Partition oldPartition = partition;
		partition = newPartition;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_APPLICATION__PARTITION, oldPartition, partition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsIsr> getIsrs() {
		if (isrs == null) {
			isrs = new EObjectResolvingEList<OsIsr>(OsIsr.class, this, AutosarPackage.OS_APPLICATION__ISRS);
		}
		return isrs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsScheduleTable> getScheduleTables() {
		if (scheduleTables == null) {
			scheduleTables = new EObjectResolvingEList<OsScheduleTable>(OsScheduleTable.class, this, AutosarPackage.OS_APPLICATION__SCHEDULE_TABLES);
		}
		return scheduleTables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsTask> getTasks() {
		if (tasks == null) {
			tasks = new EObjectResolvingEList<OsTask>(OsTask.class, this, AutosarPackage.OS_APPLICATION__TASKS);
		}
		return tasks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsTrusted() {
		return isTrusted;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsTrusted(boolean newIsTrusted) {
		boolean oldIsTrusted = isTrusted;
		isTrusted = newIsTrusted;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_APPLICATION__IS_TRUSTED, oldIsTrusted, isTrusted));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsTrustedWithProtection() {
		return isTrustedWithProtection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsTrustedWithProtection(boolean newIsTrustedWithProtection) {
		boolean oldIsTrustedWithProtection = isTrustedWithProtection;
		isTrustedWithProtection = newIsTrustedWithProtection;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION, oldIsTrustedWithProtection, isTrustedWithProtection));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_APPLICATION__ALARMS:
				return getAlarms();
			case AutosarPackage.OS_APPLICATION__COUNTERS:
				return getCounters();
			case AutosarPackage.OS_APPLICATION__CPU_CORE:
				if (resolve) return getCpuCore();
				return basicGetCpuCore();
			case AutosarPackage.OS_APPLICATION__PARTITION:
				if (resolve) return getPartition();
				return basicGetPartition();
			case AutosarPackage.OS_APPLICATION__ISRS:
				return getIsrs();
			case AutosarPackage.OS_APPLICATION__SCHEDULE_TABLES:
				return getScheduleTables();
			case AutosarPackage.OS_APPLICATION__TASKS:
				return getTasks();
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED:
				return isIsTrusted();
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION:
				return isIsTrustedWithProtection();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_APPLICATION__ALARMS:
				getAlarms().clear();
				getAlarms().addAll((Collection<? extends OsAlarm>)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__COUNTERS:
				getCounters().clear();
				getCounters().addAll((Collection<? extends OsCounter>)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__CPU_CORE:
				setCpuCore((CpuCore)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__PARTITION:
				setPartition((Partition)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__ISRS:
				getIsrs().clear();
				getIsrs().addAll((Collection<? extends OsIsr>)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__SCHEDULE_TABLES:
				getScheduleTables().clear();
				getScheduleTables().addAll((Collection<? extends OsScheduleTable>)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__TASKS:
				getTasks().clear();
				getTasks().addAll((Collection<? extends OsTask>)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED:
				setIsTrusted((Boolean)newValue);
				return;
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION:
				setIsTrustedWithProtection((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_APPLICATION__ALARMS:
				getAlarms().clear();
				return;
			case AutosarPackage.OS_APPLICATION__COUNTERS:
				getCounters().clear();
				return;
			case AutosarPackage.OS_APPLICATION__CPU_CORE:
				setCpuCore((CpuCore)null);
				return;
			case AutosarPackage.OS_APPLICATION__PARTITION:
				setPartition((Partition)null);
				return;
			case AutosarPackage.OS_APPLICATION__ISRS:
				getIsrs().clear();
				return;
			case AutosarPackage.OS_APPLICATION__SCHEDULE_TABLES:
				getScheduleTables().clear();
				return;
			case AutosarPackage.OS_APPLICATION__TASKS:
				getTasks().clear();
				return;
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED:
				setIsTrusted(IS_TRUSTED_EDEFAULT);
				return;
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION:
				setIsTrustedWithProtection(IS_TRUSTED_WITH_PROTECTION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_APPLICATION__ALARMS:
				return alarms != null && !alarms.isEmpty();
			case AutosarPackage.OS_APPLICATION__COUNTERS:
				return counters != null && !counters.isEmpty();
			case AutosarPackage.OS_APPLICATION__CPU_CORE:
				return cpuCore != null;
			case AutosarPackage.OS_APPLICATION__PARTITION:
				return partition != null;
			case AutosarPackage.OS_APPLICATION__ISRS:
				return isrs != null && !isrs.isEmpty();
			case AutosarPackage.OS_APPLICATION__SCHEDULE_TABLES:
				return scheduleTables != null && !scheduleTables.isEmpty();
			case AutosarPackage.OS_APPLICATION__TASKS:
				return tasks != null && !tasks.isEmpty();
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED:
				return isTrusted != IS_TRUSTED_EDEFAULT;
			case AutosarPackage.OS_APPLICATION__IS_TRUSTED_WITH_PROTECTION:
				return isTrustedWithProtection != IS_TRUSTED_WITH_PROTECTION_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isTrusted: ");
		result.append(isTrusted);
		result.append(", isTrustedWithProtection: ");
		result.append(isTrustedWithProtection);
		result.append(')');
		return result.toString();
	}

} //OsApplicationImpl
