/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.Connection;

import com.inchron.realtime.root.model.peripheral.AbstractPort;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scalar Variable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCallGraph <em>Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCausality <em>Causality</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getConnections <em>Connections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getDescription <em>Description</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getInitial <em>Initial</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getTriggerType <em>Trigger Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getValueReference <em>Value Reference</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getVariability <em>Variability</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable()
 * @model abstract="true"
 * @generated
 */
public interface ScalarVariable extends AbstractPort {
	/**
	 * Returns the value of the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Call Graph</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Call Graph</em>' containment reference.
	 * @see #setCallGraph(CallGraph)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_CallGraph()
	 * @model containment="true"
	 * @generated
	 */
	CallGraph getCallGraph();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCallGraph <em>Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Call Graph</em>' containment reference.
	 * @see #getCallGraph()
	 * @generated
	 */
	void setCallGraph(CallGraph value);

	/**
	 * Returns the value of the '<em><b>Causality</b></em>' attribute.
	 * The default value is <code>"local"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.fmi.variable.Causality}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Causality</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Causality</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Causality
	 * @see #setCausality(Causality)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_Causality()
	 * @model default="local"
	 * @generated
	 */
	Causality getCausality();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCausality <em>Causality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Causality</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Causality
	 * @see #getCausality()
	 * @generated
	 */
	void setCausality(Causality value);

	/**
	 * Returns the value of the '<em><b>Connections</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Connection}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connections</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connections</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_Connections()
	 * @model containment="true"
	 * @generated
	 */
	EList<Connection> getConnections();

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_Description()
	 * @model default=""
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Initial</b></em>' attribute.
	 * The default value is <code>"unset"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.fmi.variable.Initial}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Initial
	 * @see #setInitial(Initial)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_Initial()
	 * @model default="unset"
	 * @generated
	 */
	Initial getInitial();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getInitial <em>Initial</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Initial
	 * @see #getInitial()
	 * @generated
	 */
	void setInitial(Initial value);

	/**
	 * Returns the value of the '<em><b>Trigger Type</b></em>' attribute.
	 * The default value is <code>"onChange"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.fmi.variable.TriggerType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trigger Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trigger Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.TriggerType
	 * @see #setTriggerType(TriggerType)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_TriggerType()
	 * @model default="onChange"
	 * @generated
	 */
	TriggerType getTriggerType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getTriggerType <em>Trigger Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trigger Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.TriggerType
	 * @see #getTriggerType()
	 * @generated
	 */
	void setTriggerType(TriggerType value);

	/**
	 * Returns the value of the '<em><b>Value Reference</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value Reference</em>' attribute.
	 * @see #setValueReference(int)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_ValueReference()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getValueReference();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getValueReference <em>Value Reference</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value Reference</em>' attribute.
	 * @see #getValueReference()
	 * @generated
	 */
	void setValueReference(int value);

	/**
	 * Returns the value of the '<em><b>Variability</b></em>' attribute.
	 * The default value is <code>"continuous"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.fmi.variable.Variability}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variability</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variability</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Variability
	 * @see #setVariability(Variability)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getScalarVariable_Variability()
	 * @model default="continuous"
	 * @generated
	 */
	Variability getVariability();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getVariability <em>Variability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Variability</em>' attribute.
	 * @see com.inchron.realtime.root.model.fmi.variable.Variability
	 * @see #getVariability()
	 * @generated
	 */
	void setVariability(Variability value);

} // ScalarVariable
