/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.Clock;
import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.Frequency;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceObject;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Clock</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getFrequency <em>Frequency</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getDrift <em>Drift</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getRange <em>Range</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getStartTimeFixed <em>Start Time Fixed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#isStartTimeIsRandom <em>Start Time Is Random</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getStartTimeMin <em>Start Time Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getStartTimeMax <em>Start Time Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getStartValue <em>Start Value</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ClockImpl#getUsers <em>Users</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ClockImpl extends ModelObjectImpl implements Clock {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The cached value of the '{@link #getFrequency() <em>Frequency</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFrequency()
	 * @generated
	 * @ordered
	 */
	protected Frequency frequency;

	/**
	 * The cached value of the '{@link #getPeriod() <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeriod()
	 * @generated
	 * @ordered
	 */
	protected Time period;

	/**
	 * The default value of the '{@link #getDrift() <em>Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDrift()
	 * @generated
	 * @ordered
	 */
	protected static final int DRIFT_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getDrift() <em>Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDrift()
	 * @generated
	 * @ordered
	 */
	protected int drift = DRIFT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getRange() <em>Range</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRange()
	 * @generated
	 * @ordered
	 */
	protected Time range;

	/**
	 * The cached value of the '{@link #getStartTimeFixed() <em>Start Time Fixed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTimeFixed()
	 * @generated
	 * @ordered
	 */
	protected Time startTimeFixed;

	/**
	 * The default value of the '{@link #isStartTimeIsRandom() <em>Start Time Is Random</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStartTimeIsRandom()
	 * @generated
	 * @ordered
	 */
	protected static final boolean START_TIME_IS_RANDOM_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isStartTimeIsRandom() <em>Start Time Is Random</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStartTimeIsRandom()
	 * @generated
	 * @ordered
	 */
	protected boolean startTimeIsRandom = START_TIME_IS_RANDOM_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStartTimeMin() <em>Start Time Min</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTimeMin()
	 * @generated
	 * @ordered
	 */
	protected Time startTimeMin;

	/**
	 * The cached value of the '{@link #getStartTimeMax() <em>Start Time Max</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTimeMax()
	 * @generated
	 * @ordered
	 */
	protected Time startTimeMax;

	/**
	 * The cached value of the '{@link #getStartValue() <em>Start Value</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartValue()
	 * @generated
	 * @ordered
	 */
	protected Time startValue;

	/**
	 * The cached value of the '{@link #getUsers() <em>Users</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUsers()
	 * @generated
	 * @ordered
	 */
	protected EList<ClockUser> users;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClockImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getClock();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ModelPackage.CLOCK__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Frequency getFrequency() {
		return frequency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFrequency(Frequency newFrequency, NotificationChain msgs) {
		Frequency oldFrequency = frequency;
		frequency = newFrequency;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__FREQUENCY, oldFrequency, newFrequency);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFrequency(Frequency newFrequency) {
		if (newFrequency != frequency) {
			NotificationChain msgs = null;
			if (frequency != null)
				msgs = ((InternalEObject)frequency).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__FREQUENCY, null, msgs);
			if (newFrequency != null)
				msgs = ((InternalEObject)newFrequency).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__FREQUENCY, null, msgs);
			msgs = basicSetFrequency(newFrequency, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__FREQUENCY, newFrequency, newFrequency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPeriod() {
		return period;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPeriod(Time newPeriod, NotificationChain msgs) {
		Time oldPeriod = period;
		period = newPeriod;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__PERIOD, oldPeriod, newPeriod);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPeriod(Time newPeriod) {
		if (newPeriod != period) {
			NotificationChain msgs = null;
			if (period != null)
				msgs = ((InternalEObject)period).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__PERIOD, null, msgs);
			if (newPeriod != null)
				msgs = ((InternalEObject)newPeriod).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__PERIOD, null, msgs);
			msgs = basicSetPeriod(newPeriod, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__PERIOD, newPeriod, newPeriod));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDrift() {
		return drift;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDrift(int newDrift) {
		int oldDrift = drift;
		drift = newDrift;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__DRIFT, oldDrift, drift));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getRange() {
		return range;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRange(Time newRange, NotificationChain msgs) {
		Time oldRange = range;
		range = newRange;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__RANGE, oldRange, newRange);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRange(Time newRange) {
		if (newRange != range) {
			NotificationChain msgs = null;
			if (range != null)
				msgs = ((InternalEObject)range).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__RANGE, null, msgs);
			if (newRange != null)
				msgs = ((InternalEObject)newRange).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__RANGE, null, msgs);
			msgs = basicSetRange(newRange, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__RANGE, newRange, newRange));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartTimeFixed() {
		return startTimeFixed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartTimeFixed(Time newStartTimeFixed, NotificationChain msgs) {
		Time oldStartTimeFixed = startTimeFixed;
		startTimeFixed = newStartTimeFixed;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_FIXED, oldStartTimeFixed, newStartTimeFixed);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTimeFixed(Time newStartTimeFixed) {
		if (newStartTimeFixed != startTimeFixed) {
			NotificationChain msgs = null;
			if (startTimeFixed != null)
				msgs = ((InternalEObject)startTimeFixed).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_FIXED, null, msgs);
			if (newStartTimeFixed != null)
				msgs = ((InternalEObject)newStartTimeFixed).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_FIXED, null, msgs);
			msgs = basicSetStartTimeFixed(newStartTimeFixed, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_FIXED, newStartTimeFixed, newStartTimeFixed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isStartTimeIsRandom() {
		return startTimeIsRandom;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTimeIsRandom(boolean newStartTimeIsRandom) {
		boolean oldStartTimeIsRandom = startTimeIsRandom;
		startTimeIsRandom = newStartTimeIsRandom;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_IS_RANDOM, oldStartTimeIsRandom, startTimeIsRandom));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartTimeMin() {
		return startTimeMin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartTimeMin(Time newStartTimeMin, NotificationChain msgs) {
		Time oldStartTimeMin = startTimeMin;
		startTimeMin = newStartTimeMin;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_MIN, oldStartTimeMin, newStartTimeMin);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTimeMin(Time newStartTimeMin) {
		if (newStartTimeMin != startTimeMin) {
			NotificationChain msgs = null;
			if (startTimeMin != null)
				msgs = ((InternalEObject)startTimeMin).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_MIN, null, msgs);
			if (newStartTimeMin != null)
				msgs = ((InternalEObject)newStartTimeMin).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_MIN, null, msgs);
			msgs = basicSetStartTimeMin(newStartTimeMin, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_MIN, newStartTimeMin, newStartTimeMin));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartTimeMax() {
		return startTimeMax;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartTimeMax(Time newStartTimeMax, NotificationChain msgs) {
		Time oldStartTimeMax = startTimeMax;
		startTimeMax = newStartTimeMax;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_MAX, oldStartTimeMax, newStartTimeMax);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTimeMax(Time newStartTimeMax) {
		if (newStartTimeMax != startTimeMax) {
			NotificationChain msgs = null;
			if (startTimeMax != null)
				msgs = ((InternalEObject)startTimeMax).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_MAX, null, msgs);
			if (newStartTimeMax != null)
				msgs = ((InternalEObject)newStartTimeMax).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_TIME_MAX, null, msgs);
			msgs = basicSetStartTimeMax(newStartTimeMax, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_TIME_MAX, newStartTimeMax, newStartTimeMax));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartValue() {
		return startValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartValue(Time newStartValue, NotificationChain msgs) {
		Time oldStartValue = startValue;
		startValue = newStartValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_VALUE, oldStartValue, newStartValue);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartValue(Time newStartValue) {
		if (newStartValue != startValue) {
			NotificationChain msgs = null;
			if (startValue != null)
				msgs = ((InternalEObject)startValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_VALUE, null, msgs);
			if (newStartValue != null)
				msgs = ((InternalEObject)newStartValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CLOCK__START_VALUE, null, msgs);
			msgs = basicSetStartValue(newStartValue, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CLOCK__START_VALUE, newStartValue, newStartValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ClockUser> getUsers() {
		if (users == null) {
			users = new EObjectWithInverseResolvingEList<ClockUser>(ClockUser.class, this, ModelPackage.CLOCK__USERS, ModelPackage.CLOCK_USER__CLOCK);
		}
		return users;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.CLOCK__USERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getUsers()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.CLOCK__FREQUENCY:
				return basicSetFrequency(null, msgs);
			case ModelPackage.CLOCK__PERIOD:
				return basicSetPeriod(null, msgs);
			case ModelPackage.CLOCK__RANGE:
				return basicSetRange(null, msgs);
			case ModelPackage.CLOCK__START_TIME_FIXED:
				return basicSetStartTimeFixed(null, msgs);
			case ModelPackage.CLOCK__START_TIME_MIN:
				return basicSetStartTimeMin(null, msgs);
			case ModelPackage.CLOCK__START_TIME_MAX:
				return basicSetStartTimeMax(null, msgs);
			case ModelPackage.CLOCK__START_VALUE:
				return basicSetStartValue(null, msgs);
			case ModelPackage.CLOCK__USERS:
				return ((InternalEList<?>)getUsers()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CLOCK__OBJECT_ID:
				return getObjectId();
			case ModelPackage.CLOCK__FREQUENCY:
				return getFrequency();
			case ModelPackage.CLOCK__PERIOD:
				return getPeriod();
			case ModelPackage.CLOCK__DRIFT:
				return getDrift();
			case ModelPackage.CLOCK__RANGE:
				return getRange();
			case ModelPackage.CLOCK__START_TIME_FIXED:
				return getStartTimeFixed();
			case ModelPackage.CLOCK__START_TIME_IS_RANDOM:
				return isStartTimeIsRandom();
			case ModelPackage.CLOCK__START_TIME_MIN:
				return getStartTimeMin();
			case ModelPackage.CLOCK__START_TIME_MAX:
				return getStartTimeMax();
			case ModelPackage.CLOCK__START_VALUE:
				return getStartValue();
			case ModelPackage.CLOCK__USERS:
				return getUsers();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CLOCK__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case ModelPackage.CLOCK__FREQUENCY:
				setFrequency((Frequency)newValue);
				return;
			case ModelPackage.CLOCK__PERIOD:
				setPeriod((Time)newValue);
				return;
			case ModelPackage.CLOCK__DRIFT:
				setDrift((Integer)newValue);
				return;
			case ModelPackage.CLOCK__RANGE:
				setRange((Time)newValue);
				return;
			case ModelPackage.CLOCK__START_TIME_FIXED:
				setStartTimeFixed((Time)newValue);
				return;
			case ModelPackage.CLOCK__START_TIME_IS_RANDOM:
				setStartTimeIsRandom((Boolean)newValue);
				return;
			case ModelPackage.CLOCK__START_TIME_MIN:
				setStartTimeMin((Time)newValue);
				return;
			case ModelPackage.CLOCK__START_TIME_MAX:
				setStartTimeMax((Time)newValue);
				return;
			case ModelPackage.CLOCK__START_VALUE:
				setStartValue((Time)newValue);
				return;
			case ModelPackage.CLOCK__USERS:
				getUsers().clear();
				getUsers().addAll((Collection<? extends ClockUser>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CLOCK__OBJECT_ID:
				unsetObjectId();
				return;
			case ModelPackage.CLOCK__FREQUENCY:
				setFrequency((Frequency)null);
				return;
			case ModelPackage.CLOCK__PERIOD:
				setPeriod((Time)null);
				return;
			case ModelPackage.CLOCK__DRIFT:
				setDrift(DRIFT_EDEFAULT);
				return;
			case ModelPackage.CLOCK__RANGE:
				setRange((Time)null);
				return;
			case ModelPackage.CLOCK__START_TIME_FIXED:
				setStartTimeFixed((Time)null);
				return;
			case ModelPackage.CLOCK__START_TIME_IS_RANDOM:
				setStartTimeIsRandom(START_TIME_IS_RANDOM_EDEFAULT);
				return;
			case ModelPackage.CLOCK__START_TIME_MIN:
				setStartTimeMin((Time)null);
				return;
			case ModelPackage.CLOCK__START_TIME_MAX:
				setStartTimeMax((Time)null);
				return;
			case ModelPackage.CLOCK__START_VALUE:
				setStartValue((Time)null);
				return;
			case ModelPackage.CLOCK__USERS:
				getUsers().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CLOCK__OBJECT_ID:
				return isSetObjectId();
			case ModelPackage.CLOCK__FREQUENCY:
				return frequency != null;
			case ModelPackage.CLOCK__PERIOD:
				return period != null;
			case ModelPackage.CLOCK__DRIFT:
				return drift != DRIFT_EDEFAULT;
			case ModelPackage.CLOCK__RANGE:
				return range != null;
			case ModelPackage.CLOCK__START_TIME_FIXED:
				return startTimeFixed != null;
			case ModelPackage.CLOCK__START_TIME_IS_RANDOM:
				return startTimeIsRandom != START_TIME_IS_RANDOM_EDEFAULT;
			case ModelPackage.CLOCK__START_TIME_MIN:
				return startTimeMin != null;
			case ModelPackage.CLOCK__START_TIME_MAX:
				return startTimeMax != null;
			case ModelPackage.CLOCK__START_VALUE:
				return startValue != null;
			case ModelPackage.CLOCK__USERS:
				return users != null && !users.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case ModelPackage.CLOCK__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return ModelPackage.CLOCK__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(", drift: ");
		result.append(drift);
		result.append(", startTimeIsRandom: ");
		result.append(startTimeIsRandom);
		result.append(')');
		return result.toString();
	}

} //ClockImpl
