/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.ResourceConsumption;
import com.inchron.realtime.root.model.SourceFunction;
import com.inchron.realtime.root.model.TimeDistribution;

import com.inchron.realtime.root.model.memory.DataAccess;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Resource Consumption</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl#getDataAccess <em>Data Access</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl#getEntryFunction <em>Entry Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl#getStackUsage <em>Stack Usage</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl#getTimeDistribution <em>Time Distribution</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl#isUseEntryFunction <em>Use Entry Function</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ResourceConsumptionImpl extends CallSequenceItemImpl implements ResourceConsumption {
	/**
	 * The cached value of the '{@link #getDataAccess() <em>Data Access</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataAccess()
	 * @generated
	 * @ordered
	 */
	protected EList<DataAccess> dataAccess;

	/**
	 * The cached value of the '{@link #getEntryFunction() <em>Entry Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntryFunction()
	 * @generated
	 * @ordered
	 */
	protected SourceFunction entryFunction;

	/**
	 * The default value of the '{@link #getStackUsage() <em>Stack Usage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStackUsage()
	 * @generated
	 * @ordered
	 */
	protected static final int STACK_USAGE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStackUsage() <em>Stack Usage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStackUsage()
	 * @generated
	 * @ordered
	 */
	protected int stackUsage = STACK_USAGE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTimeDistribution() <em>Time Distribution</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeDistribution()
	 * @generated
	 * @ordered
	 */
	protected TimeDistribution timeDistribution;

	/**
	 * The default value of the '{@link #isUseEntryFunction() <em>Use Entry Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUseEntryFunction()
	 * @generated
	 * @ordered
	 */
	protected static final boolean USE_ENTRY_FUNCTION_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isUseEntryFunction() <em>Use Entry Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUseEntryFunction()
	 * @generated
	 * @ordered
	 */
	protected boolean useEntryFunction = USE_ENTRY_FUNCTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceConsumptionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getResourceConsumption();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataAccess> getDataAccess() {
		if (dataAccess == null) {
			dataAccess = new EObjectContainmentEList<DataAccess>(DataAccess.class, this, ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS);
		}
		return dataAccess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction getEntryFunction() {
		if (entryFunction != null && entryFunction.eIsProxy()) {
			InternalEObject oldEntryFunction = (InternalEObject)entryFunction;
			entryFunction = (SourceFunction)eResolveProxy(oldEntryFunction);
			if (entryFunction != oldEntryFunction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION, oldEntryFunction, entryFunction));
			}
		}
		return entryFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction basicGetEntryFunction() {
		return entryFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEntryFunction(SourceFunction newEntryFunction) {
		SourceFunction oldEntryFunction = entryFunction;
		entryFunction = newEntryFunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION, oldEntryFunction, entryFunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStackUsage() {
		return stackUsage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStackUsage(int newStackUsage) {
		int oldStackUsage = stackUsage;
		stackUsage = newStackUsage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RESOURCE_CONSUMPTION__STACK_USAGE, oldStackUsage, stackUsage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistribution getTimeDistribution() {
		return timeDistribution;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTimeDistribution(TimeDistribution newTimeDistribution, NotificationChain msgs) {
		TimeDistribution oldTimeDistribution = timeDistribution;
		timeDistribution = newTimeDistribution;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION, oldTimeDistribution, newTimeDistribution);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimeDistribution(TimeDistribution newTimeDistribution) {
		if (newTimeDistribution != timeDistribution) {
			NotificationChain msgs = null;
			if (timeDistribution != null)
				msgs = ((InternalEObject)timeDistribution).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION, null, msgs);
			if (newTimeDistribution != null)
				msgs = ((InternalEObject)newTimeDistribution).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION, null, msgs);
			msgs = basicSetTimeDistribution(newTimeDistribution, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION, newTimeDistribution, newTimeDistribution));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isUseEntryFunction() {
		return useEntryFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUseEntryFunction(boolean newUseEntryFunction) {
		boolean oldUseEntryFunction = useEntryFunction;
		useEntryFunction = newUseEntryFunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION, oldUseEntryFunction, useEntryFunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS:
				return ((InternalEList<?>)getDataAccess()).basicRemove(otherEnd, msgs);
			case ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION:
				return basicSetTimeDistribution(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS:
				return getDataAccess();
			case ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION:
				if (resolve) return getEntryFunction();
				return basicGetEntryFunction();
			case ModelPackage.RESOURCE_CONSUMPTION__STACK_USAGE:
				return getStackUsage();
			case ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION:
				return getTimeDistribution();
			case ModelPackage.RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION:
				return isUseEntryFunction();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS:
				getDataAccess().clear();
				getDataAccess().addAll((Collection<? extends DataAccess>)newValue);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION:
				setEntryFunction((SourceFunction)newValue);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__STACK_USAGE:
				setStackUsage((Integer)newValue);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION:
				setTimeDistribution((TimeDistribution)newValue);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION:
				setUseEntryFunction((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS:
				getDataAccess().clear();
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION:
				setEntryFunction((SourceFunction)null);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__STACK_USAGE:
				setStackUsage(STACK_USAGE_EDEFAULT);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION:
				setTimeDistribution((TimeDistribution)null);
				return;
			case ModelPackage.RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION:
				setUseEntryFunction(USE_ENTRY_FUNCTION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.RESOURCE_CONSUMPTION__DATA_ACCESS:
				return dataAccess != null && !dataAccess.isEmpty();
			case ModelPackage.RESOURCE_CONSUMPTION__ENTRY_FUNCTION:
				return entryFunction != null;
			case ModelPackage.RESOURCE_CONSUMPTION__STACK_USAGE:
				return stackUsage != STACK_USAGE_EDEFAULT;
			case ModelPackage.RESOURCE_CONSUMPTION__TIME_DISTRIBUTION:
				return timeDistribution != null;
			case ModelPackage.RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION:
				return useEntryFunction != USE_ENTRY_FUNCTION_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (stackUsage: ");
		result.append(stackUsage);
		result.append(", useEntryFunction: ");
		result.append(useEntryFunction);
		result.append(')');
		return result.toString();
	}

} //ResourceConsumptionImpl
