/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.RtosApiType;
import com.inchron.realtime.root.model.RtosModel;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rtos Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#isReloadRtosModel <em>Reload Rtos Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getRtosProperties <em>Rtos Properties</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getReturnType <em>Return Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getLibrary <em>Library</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getHeader <em>Header</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getNameSpace <em>Name Space</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getUserHeader <em>User Header</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getStateNames <em>State Names</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getApiPrefix <em>Api Prefix</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.RtosModelImpl#getRtosApiType <em>Rtos Api Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RtosModelImpl extends MinimalEObjectImpl.Container implements RtosModel {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #isReloadRtosModel() <em>Reload Rtos Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReloadRtosModel()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RELOAD_RTOS_MODEL_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isReloadRtosModel() <em>Reload Rtos Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReloadRtosModel()
	 * @generated
	 * @ordered
	 */
	protected boolean reloadRtosModel = RELOAD_RTOS_MODEL_EDEFAULT;

	/**
	 * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected static final String VERSION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected String version = VERSION_EDEFAULT;

	/**
	 * The default value of the '{@link #getRtosProperties() <em>Rtos Properties</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosProperties()
	 * @generated
	 * @ordered
	 */
	protected static final int RTOS_PROPERTIES_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getRtosProperties() <em>Rtos Properties</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosProperties()
	 * @generated
	 * @ordered
	 */
	protected int rtosProperties = RTOS_PROPERTIES_EDEFAULT;

	/**
	 * The default value of the '{@link #getReturnType() <em>Return Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReturnType()
	 * @generated
	 * @ordered
	 */
	protected static final String RETURN_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getReturnType() <em>Return Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReturnType()
	 * @generated
	 * @ordered
	 */
	protected String returnType = RETURN_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getLibrary() <em>Library</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLibrary()
	 * @generated
	 * @ordered
	 */
	protected static final String LIBRARY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLibrary() <em>Library</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLibrary()
	 * @generated
	 * @ordered
	 */
	protected String library = LIBRARY_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeader() <em>Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeader()
	 * @generated
	 * @ordered
	 */
	protected static final String HEADER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getHeader() <em>Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeader()
	 * @generated
	 * @ordered
	 */
	protected String header = HEADER_EDEFAULT;

	/**
	 * The default value of the '{@link #getNameSpace() <em>Name Space</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNameSpace()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_SPACE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getNameSpace() <em>Name Space</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNameSpace()
	 * @generated
	 * @ordered
	 */
	protected String nameSpace = NAME_SPACE_EDEFAULT;

	/**
	 * The default value of the '{@link #getUserHeader() <em>User Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserHeader()
	 * @generated
	 * @ordered
	 */
	protected static final String USER_HEADER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUserHeader() <em>User Header</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserHeader()
	 * @generated
	 * @ordered
	 */
	protected String userHeader = USER_HEADER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStateNames() <em>State Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStateNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> stateNames;

	/**
	 * The default value of the '{@link #getApiPrefix() <em>Api Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getApiPrefix()
	 * @generated
	 * @ordered
	 */
	protected static final String API_PREFIX_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getApiPrefix() <em>Api Prefix</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getApiPrefix()
	 * @generated
	 * @ordered
	 */
	protected String apiPrefix = API_PREFIX_EDEFAULT;

	/**
	 * The default value of the '{@link #getRtosApiType() <em>Rtos Api Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosApiType()
	 * @generated
	 * @ordered
	 */
	protected static final RtosApiType RTOS_API_TYPE_EDEFAULT = RtosApiType.NONE;

	/**
	 * The cached value of the '{@link #getRtosApiType() <em>Rtos Api Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosApiType()
	 * @generated
	 * @ordered
	 */
	protected RtosApiType rtosApiType = RTOS_API_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RtosModelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getRtosModel();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isReloadRtosModel() {
		return reloadRtosModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReloadRtosModel(boolean newReloadRtosModel) {
		boolean oldReloadRtosModel = reloadRtosModel;
		reloadRtosModel = newReloadRtosModel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__RELOAD_RTOS_MODEL, oldReloadRtosModel, reloadRtosModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVersion(String newVersion) {
		String oldVersion = version;
		version = newVersion;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__VERSION, oldVersion, version));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRtosProperties() {
		return rtosProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRtosProperties(int newRtosProperties) {
		int oldRtosProperties = rtosProperties;
		rtosProperties = newRtosProperties;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__RTOS_PROPERTIES, oldRtosProperties, rtosProperties));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getReturnType() {
		return returnType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReturnType(String newReturnType) {
		String oldReturnType = returnType;
		returnType = newReturnType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__RETURN_TYPE, oldReturnType, returnType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLibrary() {
		return library;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLibrary(String newLibrary) {
		String oldLibrary = library;
		library = newLibrary;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__LIBRARY, oldLibrary, library));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getHeader() {
		return header;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHeader(String newHeader) {
		String oldHeader = header;
		header = newHeader;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__HEADER, oldHeader, header));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getNameSpace() {
		return nameSpace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNameSpace(String newNameSpace) {
		String oldNameSpace = nameSpace;
		nameSpace = newNameSpace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__NAME_SPACE, oldNameSpace, nameSpace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUserHeader() {
		return userHeader;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUserHeader(String newUserHeader) {
		String oldUserHeader = userHeader;
		userHeader = newUserHeader;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__USER_HEADER, oldUserHeader, userHeader));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getStateNames() {
		if (stateNames == null) {
			stateNames = new EDataTypeUniqueEList<String>(String.class, this, ModelPackage.RTOS_MODEL__STATE_NAMES);
		}
		return stateNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getApiPrefix() {
		return apiPrefix;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setApiPrefix(String newApiPrefix) {
		String oldApiPrefix = apiPrefix;
		apiPrefix = newApiPrefix;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__API_PREFIX, oldApiPrefix, apiPrefix));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RtosApiType getRtosApiType() {
		return rtosApiType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRtosApiType(RtosApiType newRtosApiType) {
		RtosApiType oldRtosApiType = rtosApiType;
		rtosApiType = newRtosApiType == null ? RTOS_API_TYPE_EDEFAULT : newRtosApiType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.RTOS_MODEL__RTOS_API_TYPE, oldRtosApiType, rtosApiType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.RTOS_MODEL__NAME:
				return getName();
			case ModelPackage.RTOS_MODEL__RELOAD_RTOS_MODEL:
				return isReloadRtosModel();
			case ModelPackage.RTOS_MODEL__VERSION:
				return getVersion();
			case ModelPackage.RTOS_MODEL__RTOS_PROPERTIES:
				return getRtosProperties();
			case ModelPackage.RTOS_MODEL__RETURN_TYPE:
				return getReturnType();
			case ModelPackage.RTOS_MODEL__LIBRARY:
				return getLibrary();
			case ModelPackage.RTOS_MODEL__HEADER:
				return getHeader();
			case ModelPackage.RTOS_MODEL__NAME_SPACE:
				return getNameSpace();
			case ModelPackage.RTOS_MODEL__USER_HEADER:
				return getUserHeader();
			case ModelPackage.RTOS_MODEL__STATE_NAMES:
				return getStateNames();
			case ModelPackage.RTOS_MODEL__API_PREFIX:
				return getApiPrefix();
			case ModelPackage.RTOS_MODEL__RTOS_API_TYPE:
				return getRtosApiType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.RTOS_MODEL__NAME:
				setName((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__RELOAD_RTOS_MODEL:
				setReloadRtosModel((Boolean)newValue);
				return;
			case ModelPackage.RTOS_MODEL__VERSION:
				setVersion((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__RTOS_PROPERTIES:
				setRtosProperties((Integer)newValue);
				return;
			case ModelPackage.RTOS_MODEL__RETURN_TYPE:
				setReturnType((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__LIBRARY:
				setLibrary((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__HEADER:
				setHeader((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__NAME_SPACE:
				setNameSpace((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__USER_HEADER:
				setUserHeader((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__STATE_NAMES:
				getStateNames().clear();
				getStateNames().addAll((Collection<? extends String>)newValue);
				return;
			case ModelPackage.RTOS_MODEL__API_PREFIX:
				setApiPrefix((String)newValue);
				return;
			case ModelPackage.RTOS_MODEL__RTOS_API_TYPE:
				setRtosApiType((RtosApiType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.RTOS_MODEL__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__RELOAD_RTOS_MODEL:
				setReloadRtosModel(RELOAD_RTOS_MODEL_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__VERSION:
				setVersion(VERSION_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__RTOS_PROPERTIES:
				setRtosProperties(RTOS_PROPERTIES_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__RETURN_TYPE:
				setReturnType(RETURN_TYPE_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__LIBRARY:
				setLibrary(LIBRARY_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__HEADER:
				setHeader(HEADER_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__NAME_SPACE:
				setNameSpace(NAME_SPACE_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__USER_HEADER:
				setUserHeader(USER_HEADER_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__STATE_NAMES:
				getStateNames().clear();
				return;
			case ModelPackage.RTOS_MODEL__API_PREFIX:
				setApiPrefix(API_PREFIX_EDEFAULT);
				return;
			case ModelPackage.RTOS_MODEL__RTOS_API_TYPE:
				setRtosApiType(RTOS_API_TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.RTOS_MODEL__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ModelPackage.RTOS_MODEL__RELOAD_RTOS_MODEL:
				return reloadRtosModel != RELOAD_RTOS_MODEL_EDEFAULT;
			case ModelPackage.RTOS_MODEL__VERSION:
				return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals(version);
			case ModelPackage.RTOS_MODEL__RTOS_PROPERTIES:
				return rtosProperties != RTOS_PROPERTIES_EDEFAULT;
			case ModelPackage.RTOS_MODEL__RETURN_TYPE:
				return RETURN_TYPE_EDEFAULT == null ? returnType != null : !RETURN_TYPE_EDEFAULT.equals(returnType);
			case ModelPackage.RTOS_MODEL__LIBRARY:
				return LIBRARY_EDEFAULT == null ? library != null : !LIBRARY_EDEFAULT.equals(library);
			case ModelPackage.RTOS_MODEL__HEADER:
				return HEADER_EDEFAULT == null ? header != null : !HEADER_EDEFAULT.equals(header);
			case ModelPackage.RTOS_MODEL__NAME_SPACE:
				return NAME_SPACE_EDEFAULT == null ? nameSpace != null : !NAME_SPACE_EDEFAULT.equals(nameSpace);
			case ModelPackage.RTOS_MODEL__USER_HEADER:
				return USER_HEADER_EDEFAULT == null ? userHeader != null : !USER_HEADER_EDEFAULT.equals(userHeader);
			case ModelPackage.RTOS_MODEL__STATE_NAMES:
				return stateNames != null && !stateNames.isEmpty();
			case ModelPackage.RTOS_MODEL__API_PREFIX:
				return API_PREFIX_EDEFAULT == null ? apiPrefix != null : !API_PREFIX_EDEFAULT.equals(apiPrefix);
			case ModelPackage.RTOS_MODEL__RTOS_API_TYPE:
				return rtosApiType != RTOS_API_TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", reloadRtosModel: ");
		result.append(reloadRtosModel);
		result.append(", version: ");
		result.append(version);
		result.append(", rtosProperties: ");
		result.append(rtosProperties);
		result.append(", returnType: ");
		result.append(returnType);
		result.append(", library: ");
		result.append(library);
		result.append(", header: ");
		result.append(header);
		result.append(", nameSpace: ");
		result.append(nameSpace);
		result.append(", userHeader: ");
		result.append(userHeader);
		result.append(", stateNames: ");
		result.append(stateNames);
		result.append(", apiPrefix: ");
		result.append(apiPrefix);
		result.append(", rtosApiType: ");
		result.append(rtosApiType);
		result.append(')');
		return result.toString();
	}

} //RtosModelImpl
