/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Spinlock;
import com.inchron.realtime.root.model.SpinlockOperation;
import com.inchron.realtime.root.model.SpinlockOperationType;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Spinlock Operation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SpinlockOperationImpl#getOperation <em>Operation</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SpinlockOperationImpl#getSpinlock <em>Spinlock</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SpinlockOperationImpl extends CallSequenceItemImpl implements SpinlockOperation {
	/**
	 * The default value of the '{@link #getOperation() <em>Operation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperation()
	 * @generated
	 * @ordered
	 */
	protected static final SpinlockOperationType OPERATION_EDEFAULT = SpinlockOperationType.ACQUIRE;

	/**
	 * The cached value of the '{@link #getOperation() <em>Operation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperation()
	 * @generated
	 * @ordered
	 */
	protected SpinlockOperationType operation = OPERATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSpinlock() <em>Spinlock</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpinlock()
	 * @generated
	 * @ordered
	 */
	protected Spinlock spinlock;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SpinlockOperationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSpinlockOperation();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SpinlockOperationType getOperation() {
		return operation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOperation(SpinlockOperationType newOperation) {
		SpinlockOperationType oldOperation = operation;
		operation = newOperation == null ? OPERATION_EDEFAULT : newOperation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SPINLOCK_OPERATION__OPERATION, oldOperation, operation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Spinlock getSpinlock() {
		if (spinlock != null && spinlock.eIsProxy()) {
			InternalEObject oldSpinlock = (InternalEObject)spinlock;
			spinlock = (Spinlock)eResolveProxy(oldSpinlock);
			if (spinlock != oldSpinlock) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.SPINLOCK_OPERATION__SPINLOCK, oldSpinlock, spinlock));
			}
		}
		return spinlock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Spinlock basicGetSpinlock() {
		return spinlock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpinlock(Spinlock newSpinlock) {
		Spinlock oldSpinlock = spinlock;
		spinlock = newSpinlock;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SPINLOCK_OPERATION__SPINLOCK, oldSpinlock, spinlock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SPINLOCK_OPERATION__OPERATION:
				return getOperation();
			case ModelPackage.SPINLOCK_OPERATION__SPINLOCK:
				if (resolve) return getSpinlock();
				return basicGetSpinlock();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SPINLOCK_OPERATION__OPERATION:
				setOperation((SpinlockOperationType)newValue);
				return;
			case ModelPackage.SPINLOCK_OPERATION__SPINLOCK:
				setSpinlock((Spinlock)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SPINLOCK_OPERATION__OPERATION:
				setOperation(OPERATION_EDEFAULT);
				return;
			case ModelPackage.SPINLOCK_OPERATION__SPINLOCK:
				setSpinlock((Spinlock)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SPINLOCK_OPERATION__OPERATION:
				return operation != OPERATION_EDEFAULT;
			case ModelPackage.SPINLOCK_OPERATION__SPINLOCK:
				return spinlock != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (operation: ");
		result.append(operation);
		result.append(')');
		return result.toString();
	}

} //SpinlockOperationImpl
