/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CompilerSettings;
import com.inchron.realtime.root.model.Component;
import com.inchron.realtime.root.model.ModeCondition;
import com.inchron.realtime.root.model.ModeGroup;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.RtosModel;
import com.inchron.realtime.root.model.SpecSettings;
import com.inchron.realtime.root.model.TranslationUnit;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>System</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getCompilerSettings <em>Compiler Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getComponents <em>Components</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getModeConditions <em>Mode Conditions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getModeGroups <em>Mode Groups</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getRtosModel <em>Rtos Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getSpecSettings <em>Spec Settings</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SystemImpl#getTranslationUnits <em>Translation Units</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class SystemImpl extends ModelObjectImpl implements com.inchron.realtime.root.model.System {
	/**
	 * The cached value of the '{@link #getCompilerSettings() <em>Compiler Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCompilerSettings()
	 * @generated
	 * @ordered
	 */
	protected CompilerSettings compilerSettings;

	/**
	 * The cached value of the '{@link #getComponents() <em>Components</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponents()
	 * @generated
	 * @ordered
	 */
	protected EList<Component> components;

	/**
	 * The cached value of the '{@link #getModeConditions() <em>Mode Conditions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModeConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<ModeCondition> modeConditions;

	/**
	 * The cached value of the '{@link #getModeGroups() <em>Mode Groups</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModeGroups()
	 * @generated
	 * @ordered
	 */
	protected EList<ModeGroup> modeGroups;

	/**
	 * The cached value of the '{@link #getRtosModel() <em>Rtos Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRtosModel()
	 * @generated
	 * @ordered
	 */
	protected RtosModel rtosModel;

	/**
	 * The cached value of the '{@link #getSpecSettings() <em>Spec Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpecSettings()
	 * @generated
	 * @ordered
	 */
	protected SpecSettings specSettings;

	/**
	 * The cached value of the '{@link #getTranslationUnits() <em>Translation Units</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTranslationUnits()
	 * @generated
	 * @ordered
	 */
	protected EList<TranslationUnit> translationUnits;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSystem();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompilerSettings getCompilerSettings() {
		return compilerSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCompilerSettings(CompilerSettings newCompilerSettings, NotificationChain msgs) {
		CompilerSettings oldCompilerSettings = compilerSettings;
		compilerSettings = newCompilerSettings;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__COMPILER_SETTINGS, oldCompilerSettings, newCompilerSettings);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCompilerSettings(CompilerSettings newCompilerSettings) {
		if (newCompilerSettings != compilerSettings) {
			NotificationChain msgs = null;
			if (compilerSettings != null)
				msgs = ((InternalEObject)compilerSettings).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__COMPILER_SETTINGS, null, msgs);
			if (newCompilerSettings != null)
				msgs = ((InternalEObject)newCompilerSettings).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__COMPILER_SETTINGS, null, msgs);
			msgs = basicSetCompilerSettings(newCompilerSettings, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__COMPILER_SETTINGS, newCompilerSettings, newCompilerSettings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Component> getComponents() {
		if (components == null) {
			components = new EObjectContainmentEList<Component>(Component.class, this, ModelPackage.SYSTEM__COMPONENTS);
		}
		return components;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModeCondition> getModeConditions() {
		if (modeConditions == null) {
			modeConditions = new EObjectContainmentEList<ModeCondition>(ModeCondition.class, this, ModelPackage.SYSTEM__MODE_CONDITIONS);
		}
		return modeConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModeGroup> getModeGroups() {
		if (modeGroups == null) {
			modeGroups = new EObjectContainmentEList<ModeGroup>(ModeGroup.class, this, ModelPackage.SYSTEM__MODE_GROUPS);
		}
		return modeGroups;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RtosModel getRtosModel() {
		return rtosModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRtosModel(RtosModel newRtosModel, NotificationChain msgs) {
		RtosModel oldRtosModel = rtosModel;
		rtosModel = newRtosModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__RTOS_MODEL, oldRtosModel, newRtosModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRtosModel(RtosModel newRtosModel) {
		if (newRtosModel != rtosModel) {
			NotificationChain msgs = null;
			if (rtosModel != null)
				msgs = ((InternalEObject)rtosModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__RTOS_MODEL, null, msgs);
			if (newRtosModel != null)
				msgs = ((InternalEObject)newRtosModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__RTOS_MODEL, null, msgs);
			msgs = basicSetRtosModel(newRtosModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__RTOS_MODEL, newRtosModel, newRtosModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SpecSettings getSpecSettings() {
		return specSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSpecSettings(SpecSettings newSpecSettings, NotificationChain msgs) {
		SpecSettings oldSpecSettings = specSettings;
		specSettings = newSpecSettings;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__SPEC_SETTINGS, oldSpecSettings, newSpecSettings);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpecSettings(SpecSettings newSpecSettings) {
		if (newSpecSettings != specSettings) {
			NotificationChain msgs = null;
			if (specSettings != null)
				msgs = ((InternalEObject)specSettings).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__SPEC_SETTINGS, null, msgs);
			if (newSpecSettings != null)
				msgs = ((InternalEObject)newSpecSettings).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SYSTEM__SPEC_SETTINGS, null, msgs);
			msgs = basicSetSpecSettings(newSpecSettings, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SYSTEM__SPEC_SETTINGS, newSpecSettings, newSpecSettings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TranslationUnit> getTranslationUnits() {
		if (translationUnits == null) {
			translationUnits = new EObjectContainmentEList<TranslationUnit>(TranslationUnit.class, this, ModelPackage.SYSTEM__TRANSLATION_UNITS);
		}
		return translationUnits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.SYSTEM__COMPILER_SETTINGS:
				return basicSetCompilerSettings(null, msgs);
			case ModelPackage.SYSTEM__COMPONENTS:
				return ((InternalEList<?>)getComponents()).basicRemove(otherEnd, msgs);
			case ModelPackage.SYSTEM__MODE_CONDITIONS:
				return ((InternalEList<?>)getModeConditions()).basicRemove(otherEnd, msgs);
			case ModelPackage.SYSTEM__MODE_GROUPS:
				return ((InternalEList<?>)getModeGroups()).basicRemove(otherEnd, msgs);
			case ModelPackage.SYSTEM__RTOS_MODEL:
				return basicSetRtosModel(null, msgs);
			case ModelPackage.SYSTEM__SPEC_SETTINGS:
				return basicSetSpecSettings(null, msgs);
			case ModelPackage.SYSTEM__TRANSLATION_UNITS:
				return ((InternalEList<?>)getTranslationUnits()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SYSTEM__COMPILER_SETTINGS:
				return getCompilerSettings();
			case ModelPackage.SYSTEM__COMPONENTS:
				return getComponents();
			case ModelPackage.SYSTEM__MODE_CONDITIONS:
				return getModeConditions();
			case ModelPackage.SYSTEM__MODE_GROUPS:
				return getModeGroups();
			case ModelPackage.SYSTEM__RTOS_MODEL:
				return getRtosModel();
			case ModelPackage.SYSTEM__SPEC_SETTINGS:
				return getSpecSettings();
			case ModelPackage.SYSTEM__TRANSLATION_UNITS:
				return getTranslationUnits();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SYSTEM__COMPILER_SETTINGS:
				setCompilerSettings((CompilerSettings)newValue);
				return;
			case ModelPackage.SYSTEM__COMPONENTS:
				getComponents().clear();
				getComponents().addAll((Collection<? extends Component>)newValue);
				return;
			case ModelPackage.SYSTEM__MODE_CONDITIONS:
				getModeConditions().clear();
				getModeConditions().addAll((Collection<? extends ModeCondition>)newValue);
				return;
			case ModelPackage.SYSTEM__MODE_GROUPS:
				getModeGroups().clear();
				getModeGroups().addAll((Collection<? extends ModeGroup>)newValue);
				return;
			case ModelPackage.SYSTEM__RTOS_MODEL:
				setRtosModel((RtosModel)newValue);
				return;
			case ModelPackage.SYSTEM__SPEC_SETTINGS:
				setSpecSettings((SpecSettings)newValue);
				return;
			case ModelPackage.SYSTEM__TRANSLATION_UNITS:
				getTranslationUnits().clear();
				getTranslationUnits().addAll((Collection<? extends TranslationUnit>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SYSTEM__COMPILER_SETTINGS:
				setCompilerSettings((CompilerSettings)null);
				return;
			case ModelPackage.SYSTEM__COMPONENTS:
				getComponents().clear();
				return;
			case ModelPackage.SYSTEM__MODE_CONDITIONS:
				getModeConditions().clear();
				return;
			case ModelPackage.SYSTEM__MODE_GROUPS:
				getModeGroups().clear();
				return;
			case ModelPackage.SYSTEM__RTOS_MODEL:
				setRtosModel((RtosModel)null);
				return;
			case ModelPackage.SYSTEM__SPEC_SETTINGS:
				setSpecSettings((SpecSettings)null);
				return;
			case ModelPackage.SYSTEM__TRANSLATION_UNITS:
				getTranslationUnits().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SYSTEM__COMPILER_SETTINGS:
				return compilerSettings != null;
			case ModelPackage.SYSTEM__COMPONENTS:
				return components != null && !components.isEmpty();
			case ModelPackage.SYSTEM__MODE_CONDITIONS:
				return modeConditions != null && !modeConditions.isEmpty();
			case ModelPackage.SYSTEM__MODE_GROUPS:
				return modeGroups != null && !modeGroups.isEmpty();
			case ModelPackage.SYSTEM__RTOS_MODEL:
				return rtosModel != null;
			case ModelPackage.SYSTEM__SPEC_SETTINGS:
				return specSettings != null;
			case ModelPackage.SYSTEM__TRANSLATION_UNITS:
				return translationUnits != null && !translationUnits.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //SystemImpl
