/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.DiscreteDistributionEntry;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TimeDistribution;
import com.inchron.realtime.root.model.TimeDistributionType;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Time Distribution</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getMean <em>Mean</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getSigma <em>Sigma</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getAlpha <em>Alpha</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getBeta <em>Beta</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getDiscreteDistribution <em>Discrete Distribution</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl#getType <em>Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TimeDistributionImpl extends MinimalEObjectImpl.Container implements TimeDistribution {
	/**
	 * The cached value of the '{@link #getMin() <em>Min</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMin()
	 * @generated
	 * @ordered
	 */
	protected Time min;

	/**
	 * The cached value of the '{@link #getMax() <em>Max</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMax()
	 * @generated
	 * @ordered
	 */
	protected Time max;

	/**
	 * The cached value of the '{@link #getMean() <em>Mean</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMean()
	 * @generated
	 * @ordered
	 */
	protected Time mean;

	/**
	 * The cached value of the '{@link #getSigma() <em>Sigma</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSigma()
	 * @generated
	 * @ordered
	 */
	protected Time sigma;

	/**
	 * The default value of the '{@link #getAlpha() <em>Alpha</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlpha()
	 * @generated
	 * @ordered
	 */
	protected static final double ALPHA_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getAlpha() <em>Alpha</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlpha()
	 * @generated
	 * @ordered
	 */
	protected double alpha = ALPHA_EDEFAULT;

	/**
	 * The default value of the '{@link #getBeta() <em>Beta</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBeta()
	 * @generated
	 * @ordered
	 */
	protected static final double BETA_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getBeta() <em>Beta</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBeta()
	 * @generated
	 * @ordered
	 */
	protected double beta = BETA_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDiscreteDistribution() <em>Discrete Distribution</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDiscreteDistribution()
	 * @generated
	 * @ordered
	 */
	protected EList<DiscreteDistributionEntry> discreteDistribution;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final TimeDistributionType TYPE_EDEFAULT = TimeDistributionType.MAX;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected TimeDistributionType type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimeDistributionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getTimeDistribution();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMin() {
		return min;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMin(Time newMin, NotificationChain msgs) {
		Time oldMin = min;
		min = newMin;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MIN, oldMin, newMin);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMin(Time newMin) {
		if (newMin != min) {
			NotificationChain msgs = null;
			if (min != null)
				msgs = ((InternalEObject)min).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MIN, null, msgs);
			if (newMin != null)
				msgs = ((InternalEObject)newMin).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MIN, null, msgs);
			msgs = basicSetMin(newMin, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MIN, newMin, newMin));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMax() {
		return max;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMax(Time newMax, NotificationChain msgs) {
		Time oldMax = max;
		max = newMax;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MAX, oldMax, newMax);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMax(Time newMax) {
		if (newMax != max) {
			NotificationChain msgs = null;
			if (max != null)
				msgs = ((InternalEObject)max).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MAX, null, msgs);
			if (newMax != null)
				msgs = ((InternalEObject)newMax).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MAX, null, msgs);
			msgs = basicSetMax(newMax, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MAX, newMax, newMax));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMean() {
		return mean;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMean(Time newMean, NotificationChain msgs) {
		Time oldMean = mean;
		mean = newMean;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MEAN, oldMean, newMean);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMean(Time newMean) {
		if (newMean != mean) {
			NotificationChain msgs = null;
			if (mean != null)
				msgs = ((InternalEObject)mean).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MEAN, null, msgs);
			if (newMean != null)
				msgs = ((InternalEObject)newMean).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__MEAN, null, msgs);
			msgs = basicSetMean(newMean, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__MEAN, newMean, newMean));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getSigma() {
		return sigma;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSigma(Time newSigma, NotificationChain msgs) {
		Time oldSigma = sigma;
		sigma = newSigma;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__SIGMA, oldSigma, newSigma);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSigma(Time newSigma) {
		if (newSigma != sigma) {
			NotificationChain msgs = null;
			if (sigma != null)
				msgs = ((InternalEObject)sigma).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__SIGMA, null, msgs);
			if (newSigma != null)
				msgs = ((InternalEObject)newSigma).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_DISTRIBUTION__SIGMA, null, msgs);
			msgs = basicSetSigma(newSigma, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__SIGMA, newSigma, newSigma));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getAlpha() {
		return alpha;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAlpha(double newAlpha) {
		double oldAlpha = alpha;
		alpha = newAlpha;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__ALPHA, oldAlpha, alpha));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getBeta() {
		return beta;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBeta(double newBeta) {
		double oldBeta = beta;
		beta = newBeta;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__BETA, oldBeta, beta));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DiscreteDistributionEntry> getDiscreteDistribution() {
		if (discreteDistribution == null) {
			discreteDistribution = new EObjectContainmentEList<DiscreteDistributionEntry>(DiscreteDistributionEntry.class, this, ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION);
		}
		return discreteDistribution;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistributionType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(TimeDistributionType newType) {
		TimeDistributionType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_DISTRIBUTION__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.TIME_DISTRIBUTION__MIN:
				return basicSetMin(null, msgs);
			case ModelPackage.TIME_DISTRIBUTION__MAX:
				return basicSetMax(null, msgs);
			case ModelPackage.TIME_DISTRIBUTION__MEAN:
				return basicSetMean(null, msgs);
			case ModelPackage.TIME_DISTRIBUTION__SIGMA:
				return basicSetSigma(null, msgs);
			case ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION:
				return ((InternalEList<?>)getDiscreteDistribution()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.TIME_DISTRIBUTION__MIN:
				return getMin();
			case ModelPackage.TIME_DISTRIBUTION__MAX:
				return getMax();
			case ModelPackage.TIME_DISTRIBUTION__MEAN:
				return getMean();
			case ModelPackage.TIME_DISTRIBUTION__SIGMA:
				return getSigma();
			case ModelPackage.TIME_DISTRIBUTION__ALPHA:
				return getAlpha();
			case ModelPackage.TIME_DISTRIBUTION__BETA:
				return getBeta();
			case ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION:
				return getDiscreteDistribution();
			case ModelPackage.TIME_DISTRIBUTION__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.TIME_DISTRIBUTION__MIN:
				setMin((Time)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__MAX:
				setMax((Time)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__MEAN:
				setMean((Time)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__SIGMA:
				setSigma((Time)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__ALPHA:
				setAlpha((Double)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__BETA:
				setBeta((Double)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION:
				getDiscreteDistribution().clear();
				getDiscreteDistribution().addAll((Collection<? extends DiscreteDistributionEntry>)newValue);
				return;
			case ModelPackage.TIME_DISTRIBUTION__TYPE:
				setType((TimeDistributionType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.TIME_DISTRIBUTION__MIN:
				setMin((Time)null);
				return;
			case ModelPackage.TIME_DISTRIBUTION__MAX:
				setMax((Time)null);
				return;
			case ModelPackage.TIME_DISTRIBUTION__MEAN:
				setMean((Time)null);
				return;
			case ModelPackage.TIME_DISTRIBUTION__SIGMA:
				setSigma((Time)null);
				return;
			case ModelPackage.TIME_DISTRIBUTION__ALPHA:
				setAlpha(ALPHA_EDEFAULT);
				return;
			case ModelPackage.TIME_DISTRIBUTION__BETA:
				setBeta(BETA_EDEFAULT);
				return;
			case ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION:
				getDiscreteDistribution().clear();
				return;
			case ModelPackage.TIME_DISTRIBUTION__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.TIME_DISTRIBUTION__MIN:
				return min != null;
			case ModelPackage.TIME_DISTRIBUTION__MAX:
				return max != null;
			case ModelPackage.TIME_DISTRIBUTION__MEAN:
				return mean != null;
			case ModelPackage.TIME_DISTRIBUTION__SIGMA:
				return sigma != null;
			case ModelPackage.TIME_DISTRIBUTION__ALPHA:
				return alpha != ALPHA_EDEFAULT;
			case ModelPackage.TIME_DISTRIBUTION__BETA:
				return beta != BETA_EDEFAULT;
			case ModelPackage.TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION:
				return discreteDistribution != null && !discreteDistribution.isEmpty();
			case ModelPackage.TIME_DISTRIBUTION__TYPE:
				return type != TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (alpha: ");
		result.append(alpha);
		result.append(", beta: ");
		result.append(beta);
		result.append(", type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //TimeDistributionImpl
