/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.TraceObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Responder Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.ResponderPort#getReadAccessPattern <em>Read Access Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.ResponderPort#getWriteAccessPattern <em>Write Access Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.ResponderPort#getInitiator <em>Initiator</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getResponderPort()
 * @model
 * @generated
 */
public interface ResponderPort extends ModelObject, TraceObject {
	/**
	 * Returns the value of the '<em><b>Read Access Pattern</b></em>' attribute.
	 * The default value is <code>"1-1-1-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Read Access Pattern</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Read Access Pattern</em>' attribute.
	 * @see #setReadAccessPattern(String)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getResponderPort_ReadAccessPattern()
	 * @model default="1-1-1-1"
	 * @generated
	 */
	String getReadAccessPattern();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.ResponderPort#getReadAccessPattern <em>Read Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Read Access Pattern</em>' attribute.
	 * @see #getReadAccessPattern()
	 * @generated
	 */
	void setReadAccessPattern(String value);

	/**
	 * Returns the value of the '<em><b>Write Access Pattern</b></em>' attribute.
	 * The default value is <code>"1-1-1-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Write Access Pattern</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Write Access Pattern</em>' attribute.
	 * @see #setWriteAccessPattern(String)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getResponderPort_WriteAccessPattern()
	 * @model default="1-1-1-1"
	 * @generated
	 */
	String getWriteAccessPattern();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.ResponderPort#getWriteAccessPattern <em>Write Access Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Write Access Pattern</em>' attribute.
	 * @see #getWriteAccessPattern()
	 * @generated
	 */
	void setWriteAccessPattern(String value);

	/**
	 * Returns the value of the '<em><b>Initiator</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.memory.InitiatorPort#getResponder <em>Responder</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initiator</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initiator</em>' reference.
	 * @see #setInitiator(InitiatorPort)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getResponderPort_Initiator()
	 * @see com.inchron.realtime.root.model.memory.InitiatorPort#getResponder
	 * @model opposite="responder"
	 * @generated
	 */
	InitiatorPort getInitiator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.ResponderPort#getInitiator <em>Initiator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initiator</em>' reference.
	 * @see #getInitiator()
	 * @generated
	 */
	void setInitiator(InitiatorPort value);

} // ResponderPort
