/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage
 * @generated
 */
public interface PeripheralFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PeripheralFactory eINSTANCE = com.inchron.realtime.root.model.peripheral.impl.PeripheralFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Bus Master Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Bus Master Port</em>'.
	 * @generated
	 */
	BusMasterPort createBusMasterPort();

	/**
	 * Returns a new object of class '<em>Bus Slave Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Bus Slave Port</em>'.
	 * @generated
	 */
	BusSlavePort createBusSlavePort();

	/**
	 * Returns a new object of class '<em>Interrupt Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Interrupt Port</em>'.
	 * @generated
	 */
	InterruptPort createInterruptPort();

	/**
	 * Returns a new object of class '<em>Input Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Input Port</em>'.
	 * @generated
	 */
	InputPort createInputPort();

	/**
	 * Returns a new object of class '<em>Output Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Output Port</em>'.
	 * @generated
	 */
	OutputPort createOutputPort();

	/**
	 * Returns a new object of class '<em>Bi Dir Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Bi Dir Port</em>'.
	 * @generated
	 */
	BiDirPort createBiDirPort();

	/**
	 * Returns a new object of class '<em>Port Connection</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Port Connection</em>'.
	 * @generated
	 */
	PortConnection createPortConnection();

	/**
	 * Returns a new object of class '<em>AFDX Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AFDX Port</em>'.
	 * @generated
	 */
	AFDXPort createAFDXPort();

	/**
	 * Returns a new object of class '<em>AFDX Ethernet</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AFDX Ethernet</em>'.
	 * @generated
	 */
	AFDXEthernet createAFDXEthernet();

	/**
	 * Returns a new object of class '<em>AS5643</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AS5643</em>'.
	 * @generated
	 */
	AS5643 createAS5643();

	/**
	 * Returns a new object of class '<em>AS5643 Bus</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AS5643 Bus</em>'.
	 * @generated
	 */
	AS5643Bus createAS5643Bus();

	/**
	 * Returns a new object of class '<em>CAN</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CAN</em>'.
	 * @generated
	 */
	CAN createCAN();

	/**
	 * Returns a new object of class '<em>CAN Bus</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CAN Bus</em>'.
	 * @generated
	 */
	CANBus createCANBus();

	/**
	 * Returns a new object of class '<em>Console</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Console</em>'.
	 * @generated
	 */
	Console createConsole();

	/**
	 * Returns a new object of class '<em>Ethernet</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ethernet</em>'.
	 * @generated
	 */
	Ethernet createEthernet();

	/**
	 * Returns a new object of class '<em>Ethernet Switch</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ethernet Switch</em>'.
	 * @generated
	 */
	EthernetSwitch createEthernetSwitch();

	/**
	 * Returns a new object of class '<em>Flex Ray</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Flex Ray</em>'.
	 * @generated
	 */
	FlexRay createFlexRay();

	/**
	 * Returns a new object of class '<em>Flex Ray Bus</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Flex Ray Bus</em>'.
	 * @generated
	 */
	FlexRayBus createFlexRayBus();

	/**
	 * Returns a new object of class '<em>Generic IO</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic IO</em>'.
	 * @generated
	 */
	GenericIO createGenericIO();

	/**
	 * Returns a new object of class '<em>IRQ</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>IRQ</em>'.
	 * @generated
	 */
	IRQ createIRQ();

	/**
	 * Returns a new object of class '<em>LIN</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>LIN</em>'.
	 * @generated
	 */
	LIN createLIN();

	/**
	 * Returns a new object of class '<em>Rest Bus</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rest Bus</em>'.
	 * @generated
	 */
	RestBus createRestBus();

	/**
	 * Returns a new object of class '<em>Rest Bus CAN</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rest Bus CAN</em>'.
	 * @generated
	 */
	RestBusCAN createRestBusCAN();

	/**
	 * Returns a new object of class '<em>Rest Bus Flex Ray</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rest Bus Flex Ray</em>'.
	 * @generated
	 */
	RestBusFlexRay createRestBusFlexRay();

	/**
	 * Returns a new object of class '<em>Timer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Timer</em>'.
	 * @generated
	 */
	Timer createTimer();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	PeripheralPackage getPeripheralPackage();

} //PeripheralFactory
