/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PeripheralFactoryImpl extends EFactoryImpl implements PeripheralFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PeripheralFactory init() {
		try {
			PeripheralFactory thePeripheralFactory = (PeripheralFactory)EPackage.Registry.INSTANCE.getEFactory(PeripheralPackage.eNS_URI);
			if (thePeripheralFactory != null) {
				return thePeripheralFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new PeripheralFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PeripheralFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case PeripheralPackage.BUS_MASTER_PORT: return createBusMasterPort();
			case PeripheralPackage.BUS_SLAVE_PORT: return createBusSlavePort();
			case PeripheralPackage.INTERRUPT_PORT: return createInterruptPort();
			case PeripheralPackage.INPUT_PORT: return createInputPort();
			case PeripheralPackage.OUTPUT_PORT: return createOutputPort();
			case PeripheralPackage.BI_DIR_PORT: return createBiDirPort();
			case PeripheralPackage.PORT_CONNECTION: return createPortConnection();
			case PeripheralPackage.AFDX_PORT: return createAFDXPort();
			case PeripheralPackage.AFDX_ETHERNET: return createAFDXEthernet();
			case PeripheralPackage.AS5643: return createAS5643();
			case PeripheralPackage.AS5643_BUS: return createAS5643Bus();
			case PeripheralPackage.CAN: return createCAN();
			case PeripheralPackage.CAN_BUS: return createCANBus();
			case PeripheralPackage.CONSOLE: return createConsole();
			case PeripheralPackage.ETHERNET: return createEthernet();
			case PeripheralPackage.ETHERNET_SWITCH: return createEthernetSwitch();
			case PeripheralPackage.FLEX_RAY: return createFlexRay();
			case PeripheralPackage.FLEX_RAY_BUS: return createFlexRayBus();
			case PeripheralPackage.GENERIC_IO: return createGenericIO();
			case PeripheralPackage.IRQ: return createIRQ();
			case PeripheralPackage.LIN: return createLIN();
			case PeripheralPackage.REST_BUS: return createRestBus();
			case PeripheralPackage.REST_BUS_CAN: return createRestBusCAN();
			case PeripheralPackage.REST_BUS_FLEX_RAY: return createRestBusFlexRay();
			case PeripheralPackage.TIMER: return createTimer();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case PeripheralPackage.AFDX_PORT_DIRECTION:
				return createAFDXPortDirectionFromString(eDataType, initialValue);
			case PeripheralPackage.AFDX_PORT_TYPE:
				return createAFDXPortTypeFromString(eDataType, initialValue);
			case PeripheralPackage.GENERIC_IO_TYPE:
				return createGenericIOTypeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case PeripheralPackage.AFDX_PORT_DIRECTION:
				return convertAFDXPortDirectionToString(eDataType, instanceValue);
			case PeripheralPackage.AFDX_PORT_TYPE:
				return convertAFDXPortTypeToString(eDataType, instanceValue);
			case PeripheralPackage.GENERIC_IO_TYPE:
				return convertGenericIOTypeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BusMasterPort createBusMasterPort() {
		BusMasterPortImpl busMasterPort = new BusMasterPortImpl();
		return busMasterPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BusSlavePort createBusSlavePort() {
		BusSlavePortImpl busSlavePort = new BusSlavePortImpl();
		return busSlavePort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterruptPort createInterruptPort() {
		InterruptPortImpl interruptPort = new InterruptPortImpl();
		return interruptPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InputPort createInputPort() {
		InputPortImpl inputPort = new InputPortImpl();
		return inputPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OutputPort createOutputPort() {
		OutputPortImpl outputPort = new OutputPortImpl();
		return outputPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BiDirPort createBiDirPort() {
		BiDirPortImpl biDirPort = new BiDirPortImpl();
		return biDirPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PortConnection createPortConnection() {
		PortConnectionImpl portConnection = new PortConnectionImpl();
		return portConnection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AFDXPort createAFDXPort() {
		AFDXPortImpl afdxPort = new AFDXPortImpl();
		return afdxPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AFDXEthernet createAFDXEthernet() {
		AFDXEthernetImpl afdxEthernet = new AFDXEthernetImpl();
		return afdxEthernet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AS5643 createAS5643() {
		AS5643Impl as5643 = new AS5643Impl();
		return as5643;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AS5643Bus createAS5643Bus() {
		AS5643BusImpl as5643Bus = new AS5643BusImpl();
		return as5643Bus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CAN createCAN() {
		CANImpl can = new CANImpl();
		return can;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CANBus createCANBus() {
		CANBusImpl canBus = new CANBusImpl();
		return canBus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Console createConsole() {
		ConsoleImpl console = new ConsoleImpl();
		return console;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Ethernet createEthernet() {
		EthernetImpl ethernet = new EthernetImpl();
		return ethernet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EthernetSwitch createEthernetSwitch() {
		EthernetSwitchImpl ethernetSwitch = new EthernetSwitchImpl();
		return ethernetSwitch;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlexRay createFlexRay() {
		FlexRayImpl flexRay = new FlexRayImpl();
		return flexRay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlexRayBus createFlexRayBus() {
		FlexRayBusImpl flexRayBus = new FlexRayBusImpl();
		return flexRayBus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericIO createGenericIO() {
		GenericIOImpl genericIO = new GenericIOImpl();
		return genericIO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IRQ createIRQ() {
		IRQImpl irq = new IRQImpl();
		return irq;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LIN createLIN() {
		LINImpl lin = new LINImpl();
		return lin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RestBus createRestBus() {
		RestBusImpl restBus = new RestBusImpl();
		return restBus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RestBusCAN createRestBusCAN() {
		RestBusCANImpl restBusCAN = new RestBusCANImpl();
		return restBusCAN;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RestBusFlexRay createRestBusFlexRay() {
		RestBusFlexRayImpl restBusFlexRay = new RestBusFlexRayImpl();
		return restBusFlexRay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Timer createTimer() {
		TimerImpl timer = new TimerImpl();
		return timer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AFDXPortDirection createAFDXPortDirectionFromString(EDataType eDataType, String initialValue) {
		AFDXPortDirection result = AFDXPortDirection.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertAFDXPortDirectionToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AFDXPortType createAFDXPortTypeFromString(EDataType eDataType, String initialValue) {
		AFDXPortType result = AFDXPortType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertAFDXPortTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericIOType createGenericIOTypeFromString(EDataType eDataType, String initialValue) {
		GenericIOType result = GenericIOType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertGenericIOTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PeripheralPackage getPeripheralPackage() {
		return (PeripheralPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static PeripheralPackage getPackage() {
		return PeripheralPackage.eINSTANCE;
	}

} //PeripheralFactoryImpl
