/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import java.util.Date;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Evaluation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Evaluation#getProvidedBy <em>Provided By</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Evaluation#getTimeCreated <em>Time Created</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Evaluation#getVerdict <em>Verdict</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEvaluation()
 * @model
 * @generated
 */
public interface Evaluation extends EObject {
	/**
	 * Returns the value of the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Provided By</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Provided By</em>' attribute.
	 * @see #setProvidedBy(String)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEvaluation_ProvidedBy()
	 * @model extendedMetaData="kind='content'"
	 * @generated
	 */
	String getProvidedBy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Evaluation#getProvidedBy <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Provided By</em>' attribute.
	 * @see #getProvidedBy()
	 * @generated
	 */
	void setProvidedBy(String value);

	/**
	 * Returns the value of the '<em><b>Time Created</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Created</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Created</em>' attribute.
	 * @see #setTimeCreated(Date)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEvaluation_TimeCreated()
	 * @model
	 * @generated
	 */
	Date getTimeCreated();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Evaluation#getTimeCreated <em>Time Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Created</em>' attribute.
	 * @see #getTimeCreated()
	 * @generated
	 */
	void setTimeCreated(Date value);

	/**
	 * Returns the value of the '<em><b>Verdict</b></em>' attribute.
	 * The default value is <code>"Unknown"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.Verdict}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Verdict</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Verdict</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.Verdict
	 * @see #setVerdict(Verdict)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEvaluation_Verdict()
	 * @model default="Unknown"
	 * @generated
	 */
	Verdict getVerdict();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Evaluation#getVerdict <em>Verdict</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Verdict</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.Verdict
	 * @see #getVerdict()
	 * @generated
	 */
	void setVerdict(Verdict value);

} // Evaluation
