/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.EventChain;
import com.inchron.realtime.root.model.EventChainStep;

import com.inchron.realtime.root.model.requirement.EventChainStrategy;
import com.inchron.realtime.root.model.requirement.EventChainTimingRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Chain Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl#getEventChain <em>Event Chain</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl#getFromStep <em>From Step</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl#getInstanceOffset <em>Instance Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl#getStrategy <em>Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl#getToStep <em>To Step</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventChainTimingRequirementImpl extends TimingRequirementImpl implements EventChainTimingRequirement {
	/**
	 * The cached value of the '{@link #getEventChain() <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventChain()
	 * @generated
	 * @ordered
	 */
	protected EventChain eventChain;

	/**
	 * The cached value of the '{@link #getFromStep() <em>From Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromStep()
	 * @generated
	 * @ordered
	 */
	protected EventChainStep fromStep;

	/**
	 * The default value of the '{@link #getInstanceOffset() <em>Instance Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstanceOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int INSTANCE_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getInstanceOffset() <em>Instance Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstanceOffset()
	 * @generated
	 * @ordered
	 */
	protected int instanceOffset = INSTANCE_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getStrategy() <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStrategy()
	 * @generated
	 * @ordered
	 */
	protected static final EventChainStrategy STRATEGY_EDEFAULT = EventChainStrategy.FIRST_FIRST;

	/**
	 * The cached value of the '{@link #getStrategy() <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStrategy()
	 * @generated
	 * @ordered
	 */
	protected EventChainStrategy strategy = STRATEGY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getToStep() <em>To Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToStep()
	 * @generated
	 * @ordered
	 */
	protected EventChainStep toStep;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventChainTimingRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVENT_CHAIN_TIMING_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain getEventChain() {
		if (eventChain != null && eventChain.eIsProxy()) {
			InternalEObject oldEventChain = (InternalEObject)eventChain;
			eventChain = (EventChain)eResolveProxy(oldEventChain);
			if (eventChain != oldEventChain) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
			}
		}
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain basicGetEventChain() {
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventChain(EventChain newEventChain) {
		EventChain oldEventChain = eventChain;
		eventChain = newEventChain;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep getFromStep() {
		if (fromStep != null && fromStep.eIsProxy()) {
			InternalEObject oldFromStep = (InternalEObject)fromStep;
			fromStep = (EventChainStep)eResolveProxy(oldFromStep);
			if (fromStep != oldFromStep) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP, oldFromStep, fromStep));
			}
		}
		return fromStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep basicGetFromStep() {
		return fromStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromStep(EventChainStep newFromStep) {
		EventChainStep oldFromStep = fromStep;
		fromStep = newFromStep;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP, oldFromStep, fromStep));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getInstanceOffset() {
		return instanceOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInstanceOffset(int newInstanceOffset) {
		int oldInstanceOffset = instanceOffset;
		instanceOffset = newInstanceOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET, oldInstanceOffset, instanceOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStrategy getStrategy() {
		return strategy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStrategy(EventChainStrategy newStrategy) {
		EventChainStrategy oldStrategy = strategy;
		strategy = newStrategy == null ? STRATEGY_EDEFAULT : newStrategy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY, oldStrategy, strategy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep getToStep() {
		if (toStep != null && toStep.eIsProxy()) {
			InternalEObject oldToStep = (InternalEObject)toStep;
			toStep = (EventChainStep)eResolveProxy(oldToStep);
			if (toStep != oldToStep) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP, oldToStep, toStep));
			}
		}
		return toStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStep basicGetToStep() {
		return toStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToStep(EventChainStep newToStep) {
		EventChainStep oldToStep = toStep;
		toStep = newToStep;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP, oldToStep, toStep));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN:
				if (resolve) return getEventChain();
				return basicGetEventChain();
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP:
				if (resolve) return getFromStep();
				return basicGetFromStep();
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET:
				return getInstanceOffset();
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY:
				return getStrategy();
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP:
				if (resolve) return getToStep();
				return basicGetToStep();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP:
				setFromStep((EventChainStep)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET:
				setInstanceOffset((Integer)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY:
				setStrategy((EventChainStrategy)newValue);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP:
				setToStep((EventChainStep)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)null);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP:
				setFromStep((EventChainStep)null);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET:
				setInstanceOffset(INSTANCE_OFFSET_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY:
				setStrategy(STRATEGY_EDEFAULT);
				return;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP:
				setToStep((EventChainStep)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN:
				return eventChain != null;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP:
				return fromStep != null;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET:
				return instanceOffset != INSTANCE_OFFSET_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY:
				return strategy != STRATEGY_EDEFAULT;
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP:
				return toStep != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (instanceOffset: ");
		result.append(instanceOffset);
		result.append(", strategy: ");
		result.append(strategy);
		result.append(')');
		return result.toString();
	}

} //EventChainTimingRequirementImpl
