/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceEvent;

import com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement;
import com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Net Slack Time Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl#getDeadlineDelta <em>Deadline Delta</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl#getDeadlineEvent <em>Deadline Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl#getType <em>Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class NetSlackTimeRequirementImpl extends TimingRequirementImpl implements NetSlackTimeRequirement {
	/**
	 * The cached value of the '{@link #getDeadlineDelta() <em>Deadline Delta</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeadlineDelta()
	 * @generated
	 * @ordered
	 */
	protected Time deadlineDelta;

	/**
	 * The cached value of the '{@link #getDeadlineEvent() <em>Deadline Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeadlineEvent()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent deadlineEvent;

	/**
	 * The cached value of the '{@link #getProcess() <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcess()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.Process process;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final NetSlackTimeRequirementType TYPE_EDEFAULT = NetSlackTimeRequirementType.DELTA;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected NetSlackTimeRequirementType type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NetSlackTimeRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.NET_SLACK_TIME_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getDeadlineDelta() {
		return deadlineDelta;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeadlineDelta(Time newDeadlineDelta, NotificationChain msgs) {
		Time oldDeadlineDelta = deadlineDelta;
		deadlineDelta = newDeadlineDelta;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA, oldDeadlineDelta, newDeadlineDelta);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeadlineDelta(Time newDeadlineDelta) {
		if (newDeadlineDelta != deadlineDelta) {
			NotificationChain msgs = null;
			if (deadlineDelta != null)
				msgs = ((InternalEObject)deadlineDelta).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA, null, msgs);
			if (newDeadlineDelta != null)
				msgs = ((InternalEObject)newDeadlineDelta).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA, null, msgs);
			msgs = basicSetDeadlineDelta(newDeadlineDelta, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA, newDeadlineDelta, newDeadlineDelta));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getDeadlineEvent() {
		if (deadlineEvent != null && deadlineEvent.eIsProxy()) {
			InternalEObject oldDeadlineEvent = (InternalEObject)deadlineEvent;
			deadlineEvent = (TraceEvent)eResolveProxy(oldDeadlineEvent);
			if (deadlineEvent != oldDeadlineEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT, oldDeadlineEvent, deadlineEvent));
			}
		}
		return deadlineEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetDeadlineEvent() {
		return deadlineEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeadlineEvent(TraceEvent newDeadlineEvent) {
		TraceEvent oldDeadlineEvent = deadlineEvent;
		deadlineEvent = newDeadlineEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT, oldDeadlineEvent, deadlineEvent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process getProcess() {
		if (process != null && process.eIsProxy()) {
			InternalEObject oldProcess = (InternalEObject)process;
			process = (com.inchron.realtime.root.model.Process)eResolveProxy(oldProcess);
			if (process != oldProcess) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS, oldProcess, process));
			}
		}
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process basicGetProcess() {
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProcess(com.inchron.realtime.root.model.Process newProcess) {
		com.inchron.realtime.root.model.Process oldProcess = process;
		process = newProcess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS, oldProcess, process));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetSlackTimeRequirementType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(NetSlackTimeRequirementType newType) {
		NetSlackTimeRequirementType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.NET_SLACK_TIME_REQUIREMENT__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA:
				return basicSetDeadlineDelta(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA:
				return getDeadlineDelta();
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT:
				if (resolve) return getDeadlineEvent();
				return basicGetDeadlineEvent();
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS:
				if (resolve) return getProcess();
				return basicGetProcess();
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA:
				setDeadlineDelta((Time)newValue);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT:
				setDeadlineEvent((TraceEvent)newValue);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)newValue);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__TYPE:
				setType((NetSlackTimeRequirementType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA:
				setDeadlineDelta((Time)null);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT:
				setDeadlineEvent((TraceEvent)null);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)null);
				return;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA:
				return deadlineDelta != null;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT:
				return deadlineEvent != null;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__PROCESS:
				return process != null;
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT__TYPE:
				return type != TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //NetSlackTimeRequirementImpl
