/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.TimeInterval;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.requirement.TimingRequirement;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getInterval <em>Interval</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#isSuccessIfOutsideOfInterval <em>Success If Outside Of Interval</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getPrewarnMarginAtLowerLimit <em>Prewarn Margin At Lower Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getPrewarnMarginAtUpperLimit <em>Prewarn Margin At Upper Limit</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class TimingRequirementImpl extends RequirementImpl implements TimingRequirement {
	/**
	 * The cached value of the '{@link #getInterval() <em>Interval</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterval()
	 * @generated
	 * @ordered
	 */
	protected TimeInterval interval;

	/**
	 * The default value of the '{@link #isSuccessIfOutsideOfInterval() <em>Success If Outside Of Interval</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSuccessIfOutsideOfInterval()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SUCCESS_IF_OUTSIDE_OF_INTERVAL_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isSuccessIfOutsideOfInterval() <em>Success If Outside Of Interval</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSuccessIfOutsideOfInterval()
	 * @generated
	 * @ordered
	 */
	protected boolean successIfOutsideOfInterval = SUCCESS_IF_OUTSIDE_OF_INTERVAL_EDEFAULT;

	/**
	 * The default value of the '{@link #getPrewarnMarginAtLowerLimit() <em>Prewarn Margin At Lower Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMarginAtLowerLimit()
	 * @generated
	 * @ordered
	 */
	protected static final float PREWARN_MARGIN_AT_LOWER_LIMIT_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getPrewarnMarginAtLowerLimit() <em>Prewarn Margin At Lower Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMarginAtLowerLimit()
	 * @generated
	 * @ordered
	 */
	protected float prewarnMarginAtLowerLimit = PREWARN_MARGIN_AT_LOWER_LIMIT_EDEFAULT;

	/**
	 * The default value of the '{@link #getPrewarnMarginAtUpperLimit() <em>Prewarn Margin At Upper Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMarginAtUpperLimit()
	 * @generated
	 * @ordered
	 */
	protected static final float PREWARN_MARGIN_AT_UPPER_LIMIT_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getPrewarnMarginAtUpperLimit() <em>Prewarn Margin At Upper Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMarginAtUpperLimit()
	 * @generated
	 * @ordered
	 */
	protected float prewarnMarginAtUpperLimit = PREWARN_MARGIN_AT_UPPER_LIMIT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimingRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.TIMING_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeInterval getInterval() {
		return interval;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInterval(TimeInterval newInterval, NotificationChain msgs) {
		TimeInterval oldInterval = interval;
		interval = newInterval;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__INTERVAL, oldInterval, newInterval);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterval(TimeInterval newInterval) {
		if (newInterval != interval) {
			NotificationChain msgs = null;
			if (interval != null)
				msgs = ((InternalEObject)interval).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__INTERVAL, null, msgs);
			if (newInterval != null)
				msgs = ((InternalEObject)newInterval).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__INTERVAL, null, msgs);
			msgs = basicSetInterval(newInterval, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__INTERVAL, newInterval, newInterval));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSuccessIfOutsideOfInterval() {
		return successIfOutsideOfInterval;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSuccessIfOutsideOfInterval(boolean newSuccessIfOutsideOfInterval) {
		boolean oldSuccessIfOutsideOfInterval = successIfOutsideOfInterval;
		successIfOutsideOfInterval = newSuccessIfOutsideOfInterval;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__SUCCESS_IF_OUTSIDE_OF_INTERVAL, oldSuccessIfOutsideOfInterval, successIfOutsideOfInterval));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getPrewarnMarginAtLowerLimit() {
		return prewarnMarginAtLowerLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrewarnMarginAtLowerLimit(float newPrewarnMarginAtLowerLimit) {
		float oldPrewarnMarginAtLowerLimit = prewarnMarginAtLowerLimit;
		prewarnMarginAtLowerLimit = newPrewarnMarginAtLowerLimit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_LOWER_LIMIT, oldPrewarnMarginAtLowerLimit, prewarnMarginAtLowerLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getPrewarnMarginAtUpperLimit() {
		return prewarnMarginAtUpperLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrewarnMarginAtUpperLimit(float newPrewarnMarginAtUpperLimit) {
		float oldPrewarnMarginAtUpperLimit = prewarnMarginAtUpperLimit;
		prewarnMarginAtUpperLimit = newPrewarnMarginAtUpperLimit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_UPPER_LIMIT, oldPrewarnMarginAtUpperLimit, prewarnMarginAtUpperLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__INTERVAL:
				return basicSetInterval(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__INTERVAL:
				return getInterval();
			case RequirementPackage.TIMING_REQUIREMENT__SUCCESS_IF_OUTSIDE_OF_INTERVAL:
				return isSuccessIfOutsideOfInterval();
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_LOWER_LIMIT:
				return getPrewarnMarginAtLowerLimit();
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_UPPER_LIMIT:
				return getPrewarnMarginAtUpperLimit();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__INTERVAL:
				setInterval((TimeInterval)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__SUCCESS_IF_OUTSIDE_OF_INTERVAL:
				setSuccessIfOutsideOfInterval((Boolean)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_LOWER_LIMIT:
				setPrewarnMarginAtLowerLimit((Float)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_UPPER_LIMIT:
				setPrewarnMarginAtUpperLimit((Float)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__INTERVAL:
				setInterval((TimeInterval)null);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__SUCCESS_IF_OUTSIDE_OF_INTERVAL:
				setSuccessIfOutsideOfInterval(SUCCESS_IF_OUTSIDE_OF_INTERVAL_EDEFAULT);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_LOWER_LIMIT:
				setPrewarnMarginAtLowerLimit(PREWARN_MARGIN_AT_LOWER_LIMIT_EDEFAULT);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_UPPER_LIMIT:
				setPrewarnMarginAtUpperLimit(PREWARN_MARGIN_AT_UPPER_LIMIT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__INTERVAL:
				return interval != null;
			case RequirementPackage.TIMING_REQUIREMENT__SUCCESS_IF_OUTSIDE_OF_INTERVAL:
				return successIfOutsideOfInterval != SUCCESS_IF_OUTSIDE_OF_INTERVAL_EDEFAULT;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_LOWER_LIMIT:
				return prewarnMarginAtLowerLimit != PREWARN_MARGIN_AT_LOWER_LIMIT_EDEFAULT;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN_AT_UPPER_LIMIT:
				return prewarnMarginAtUpperLimit != PREWARN_MARGIN_AT_UPPER_LIMIT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (successIfOutsideOfInterval: ");
		result.append(successIfOutsideOfInterval);
		result.append(", prewarnMarginAtLowerLimit: ");
		result.append(prewarnMarginAtLowerLimit);
		result.append(", prewarnMarginAtUpperLimit: ");
		result.append(prewarnMarginAtUpperLimit);
		result.append(')');
		return result.toString();
	}

} //TimingRequirementImpl
