/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.Time;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>List Based Generator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getEntry <em>Entry</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getSourceGenerator <em>Source Generator</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getListBasedGenerator()
 * @model
 * @generated
 */
public interface ListBasedGenerator extends StimuliGenerator {
	/**
	 * Returns the value of the '<em><b>Entry</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Time}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Entry</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Entry</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getListBasedGenerator_Entry()
	 * @model containment="true"
	 * @generated
	 */
	EList<Time> getEntry();

	/**
	 * Returns the value of the '<em><b>Source Generator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Generator</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source Generator</em>' reference.
	 * @see #setSourceGenerator(StimuliGenerator)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getListBasedGenerator_SourceGenerator()
	 * @model
	 * @generated
	 */
	StimuliGenerator getSourceGenerator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getSourceGenerator <em>Source Generator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source Generator</em>' reference.
	 * @see #getSourceGenerator()
	 * @generated
	 */
	void setSourceGenerator(StimuliGenerator value);

} // ListBasedGenerator
