/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage
 * @generated
 */
public interface StimulationFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	StimulationFactory eINSTANCE = com.inchron.realtime.root.model.stimulation.impl.StimulationFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Burst Pattern</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Burst Pattern</em>'.
	 * @generated
	 */
	BurstPattern createBurstPattern();

	/**
	 * Returns a new object of class '<em>Burst Pattern Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Burst Pattern Generator</em>'.
	 * @generated
	 */
	BurstPatternGenerator createBurstPatternGenerator();

	/**
	 * Returns a new object of class '<em>CSV Based Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CSV Based Generator</em>'.
	 * @generated
	 */
	CSVBasedGenerator createCSVBasedGenerator();

	/**
	 * Returns a new object of class '<em>Composite Scenario</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Composite Scenario</em>'.
	 * @generated
	 */
	CompositeScenario createCompositeScenario();

	/**
	 * Returns a new object of class '<em>Disturbance Filter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Disturbance Filter</em>'.
	 * @generated
	 */
	DisturbanceFilter createDisturbanceFilter();

	/**
	 * Returns a new object of class '<em>Drift Filter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Drift Filter</em>'.
	 * @generated
	 */
	DriftFilter createDriftFilter();

	/**
	 * Returns a new object of class '<em>Elimination Filter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Elimination Filter</em>'.
	 * @generated
	 */
	EliminationFilter createEliminationFilter();

	/**
	 * Returns a new object of class '<em>Induced Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Induced Generator</em>'.
	 * @generated
	 */
	InducedGenerator createInducedGenerator();

	/**
	 * Returns a new object of class '<em>Induced List Based Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Induced List Based Generator</em>'.
	 * @generated
	 */
	InducedListBasedGenerator createInducedListBasedGenerator();

	/**
	 * Returns a new object of class '<em>List Based Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>List Based Generator</em>'.
	 * @generated
	 */
	ListBasedGenerator createListBasedGenerator();

	/**
	 * Returns a new object of class '<em>Random Stimuli Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Random Stimuli Generator</em>'.
	 * @generated
	 */
	RandomStimuliGenerator createRandomStimuliGenerator();

	/**
	 * Returns a new object of class '<em>Scenario</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scenario</em>'.
	 * @generated
	 */
	StimulationScenario createStimulationScenario();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	StimulationPackage getStimulationPackage();

} //StimulationFactory
