 /**
 ********************************************************************************
 * Copyright (c) 2017 - 2018 Robert Bosch GmbH.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.emfutils.resourceset.mapper;

import java.util.List;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.sphinx.emf.metamodel.IMetaModelDescriptor;
import org.eclipse.sphinx.emf.metamodel.MetaModelDescriptorRegistry;
import org.eclipse.ui.IStartup;

public class ResourceSetMapper implements IStartup {

	@Override
	public void earlyStartup() {
		
		  List<IMetaModelDescriptor> descriptors = MetaModelDescriptorRegistry.INSTANCE
				.getDescriptors(MetaModelDescriptorRegistry.ANY_MM);
		  
		  for (IMetaModelDescriptor iMetaModelDescriptor : descriptors) {
			
			  ResourceSet resourceSet=new ResourceSetImpl();
				
				for (EPackage ePackage : iMetaModelDescriptor.getEPackages()) {
					
					Resource eResource = ePackage.eResource();
					
					if(eResource.getResourceSet()==null){

						((ResourceSetImpl)resourceSet).getResources().add(eResource);
						
					}
				}
		}

	}

}
