/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.peripheral.PeripheralFactory
 * @model kind="package"
 * @generated
 */
public interface PeripheralPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "peripheral";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.5/model/peripheral";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "peripheral";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PeripheralPackage eINSTANCE = com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPortImpl <em>Abstract Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractPort()
	 * @generated
	 */
	int ABSTRACT_PORT = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT__OBJECT_ID = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT__CONNECTION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Abstract Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Abstract Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PORT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusMasterPortImpl <em>Bus Master Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.BusMasterPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBusMasterPort()
	 * @generated
	 */
	int BUS_MASTER_PORT = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The number of structural features of the '<em>Bus Master Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Bus Master Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MASTER_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusSlavePortImpl <em>Bus Slave Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.BusSlavePortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBusSlavePort()
	 * @generated
	 */
	int BUS_SLAVE_PORT = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The number of structural features of the '<em>Bus Slave Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Bus Slave Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_SLAVE_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.InterruptPortImpl <em>Interrupt Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.InterruptPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getInterruptPort()
	 * @generated
	 */
	int INTERRUPT_PORT = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The feature id for the '<em><b>Isrs</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT__ISRS = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interrupt Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Interrupt Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERRUPT_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.InputPortImpl <em>Input Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.InputPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getInputPort()
	 * @generated
	 */
	int INPUT_PORT = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The number of structural features of the '<em>Input Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Input Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INPUT_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.OutputPortImpl <em>Output Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.OutputPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getOutputPort()
	 * @generated
	 */
	int OUTPUT_PORT = 5;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The number of structural features of the '<em>Output Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Output Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.BiDirPortImpl <em>Bi Dir Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.BiDirPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBiDirPort()
	 * @generated
	 */
	int BI_DIR_PORT = 6;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT__INTRINSIC_ID = ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT__NAME = ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT__OBJECT_ID = ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT__CONNECTION = ABSTRACT_PORT__CONNECTION;

	/**
	 * The number of structural features of the '<em>Bi Dir Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT_FEATURE_COUNT = ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT___IS_COMPATIBLE__ABSTRACTPORT = ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Bi Dir Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BI_DIR_PORT_OPERATION_COUNT = ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.PortConnectionImpl <em>Port Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.PortConnectionImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getPortConnection()
	 * @generated
	 */
	int PORT_CONNECTION = 7;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION__PORTS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Port Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Port Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_CONNECTION_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl <em>Abstract Peripheral</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractPeripheral()
	 * @generated
	 */
	int ABSTRACT_PERIPHERAL = 8;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__OBJECT_ID = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__EXACTNESS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__EVENTS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL__PORTS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Abstract Peripheral</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Abstract Peripheral</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_PERIPHERAL_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.PeripheralImpl <em>Peripheral</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getPeripheral()
	 * @generated
	 */
	int PERIPHERAL = 9;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__INTRINSIC_ID = ABSTRACT_PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__NAME = ABSTRACT_PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__OBJECT_ID = ABSTRACT_PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__EXACTNESS = ABSTRACT_PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__EVENTS = ABSTRACT_PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__PORTS = ABSTRACT_PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL__ADDRESS_RANGE = ABSTRACT_PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Peripheral</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL_FEATURE_COUNT = ABSTRACT_PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ABSTRACT_PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Peripheral</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIPHERAL_OPERATION_COUNT = ABSTRACT_PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusImpl <em>Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.BusImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBus()
	 * @generated
	 */
	int BUS = 10;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__INTRINSIC_ID = ABSTRACT_PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__NAME = ABSTRACT_PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__OBJECT_ID = ABSTRACT_PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__EXACTNESS = ABSTRACT_PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__EVENTS = ABSTRACT_PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS__PORTS = ABSTRACT_PERIPHERAL__PORTS;

	/**
	 * The number of structural features of the '<em>Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_FEATURE_COUNT = ABSTRACT_PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ABSTRACT_PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_OPERATION_COUNT = ABSTRACT_PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl <em>Abstract Ethernet</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractEthernet()
	 * @generated
	 */
	int ABSTRACT_ETHERNET = 11;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Auto Negotiate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__AUTO_NEGOTIATE = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Full Duplex</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__FULL_DUPLEX = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Number Of Ports</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__NUMBER_OF_PORTS = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__SPEED = PERIPHERAL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Supports Qo S</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET__SUPPORTS_QO_S = PERIPHERAL_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Abstract Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Abstract Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ETHERNET_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AFDXPortImpl <em>AFDX Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AFDXPortImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPort()
	 * @generated
	 */
	int AFDX_PORT = 12;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT__DIRECTION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT__TYPE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Queue Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT__QUEUE_LENGTH = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>AFDX Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>AFDX Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_PORT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl <em>AFDX Ethernet</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXEthernet()
	 * @generated
	 */
	int AFDX_ETHERNET = 13;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__INTRINSIC_ID = ABSTRACT_ETHERNET__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__NAME = ABSTRACT_ETHERNET__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__OBJECT_ID = ABSTRACT_ETHERNET__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__EXACTNESS = ABSTRACT_ETHERNET__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__EVENTS = ABSTRACT_ETHERNET__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__PORTS = ABSTRACT_ETHERNET__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__ADDRESS_RANGE = ABSTRACT_ETHERNET__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Auto Negotiate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__AUTO_NEGOTIATE = ABSTRACT_ETHERNET__AUTO_NEGOTIATE;

	/**
	 * The feature id for the '<em><b>Full Duplex</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__FULL_DUPLEX = ABSTRACT_ETHERNET__FULL_DUPLEX;

	/**
	 * The feature id for the '<em><b>Number Of Ports</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__NUMBER_OF_PORTS = ABSTRACT_ETHERNET__NUMBER_OF_PORTS;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__SPEED = ABSTRACT_ETHERNET__SPEED;

	/**
	 * The feature id for the '<em><b>Supports Qo S</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__SUPPORTS_QO_S = ABSTRACT_ETHERNET__SUPPORTS_QO_S;

	/**
	 * The feature id for the '<em><b>Network Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__NETWORK_ID = ABSTRACT_ETHERNET_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Equipment Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__EQUIPMENT_ID = ABSTRACT_ETHERNET_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Partition Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__PARTITION_ID = ABSTRACT_ETHERNET_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Interface Id1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__INTERFACE_ID1 = ABSTRACT_ETHERNET_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Mac1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__MAC1 = ABSTRACT_ETHERNET_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Interface Id2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__INTERFACE_ID2 = ABSTRACT_ETHERNET_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Mac2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__MAC2 = ABSTRACT_ETHERNET_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Afdx Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET__AFDX_PORTS = ABSTRACT_ETHERNET_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>AFDX Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET_FEATURE_COUNT = ABSTRACT_ETHERNET_FEATURE_COUNT + 8;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ABSTRACT_ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>AFDX Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFDX_ETHERNET_OPERATION_COUNT = ABSTRACT_ETHERNET_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl <em>AS5643</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AS5643Impl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAS5643()
	 * @generated
	 */
	int AS5643 = 14;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>CC</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__CC = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Node Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__NODE_ID = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Rank</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__RANK = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Transmission Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__TRANSMISSION_OFFSET = PERIPHERAL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Receive Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__RECEIVE_OFFSET = PERIPHERAL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Datapump Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__DATAPUMP_OFFSET = PERIPHERAL_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Monitor Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643__MONITOR_NODE = PERIPHERAL_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>AS5643</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 7;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>AS5643</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl <em>AS5643 Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAS5643Bus()
	 * @generated
	 */
	int AS5643_BUS = 15;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__PORTS = BUS__PORTS;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__SPEED = BUS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Frame Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS__FRAME_LENGTH = BUS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>AS5643 Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS_FEATURE_COUNT = BUS_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>AS5643 Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AS5643_BUS_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.CANImpl <em>CAN</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.CANImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getCAN()
	 * @generated
	 */
	int CAN = 16;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Buffer Strategy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__BUFFER_STRATEGY = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Number Of Buffers</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN__NUMBER_OF_BUFFERS = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>CAN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>CAN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.CANBusImpl <em>CAN Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.CANBusImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getCANBus()
	 * @generated
	 */
	int CAN_BUS = 17;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__PORTS = BUS__PORTS;

	/**
	 * The feature id for the '<em><b>Log Enabled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__LOG_ENABLED = BUS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__SPEED = BUS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Data Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS__DATA_SPEED = BUS_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>CAN Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_FEATURE_COUNT = BUS_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>CAN Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.ConsoleImpl <em>Console</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.ConsoleImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getConsole()
	 * @generated
	 */
	int CONSOLE = 18;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The number of structural features of the '<em>Console</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Console</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSOLE_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.EthernetImpl <em>Ethernet</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.EthernetImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getEthernet()
	 * @generated
	 */
	int ETHERNET = 19;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__INTRINSIC_ID = ABSTRACT_ETHERNET__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__NAME = ABSTRACT_ETHERNET__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__OBJECT_ID = ABSTRACT_ETHERNET__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__EXACTNESS = ABSTRACT_ETHERNET__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__EVENTS = ABSTRACT_ETHERNET__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__PORTS = ABSTRACT_ETHERNET__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__ADDRESS_RANGE = ABSTRACT_ETHERNET__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Auto Negotiate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__AUTO_NEGOTIATE = ABSTRACT_ETHERNET__AUTO_NEGOTIATE;

	/**
	 * The feature id for the '<em><b>Full Duplex</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__FULL_DUPLEX = ABSTRACT_ETHERNET__FULL_DUPLEX;

	/**
	 * The feature id for the '<em><b>Number Of Ports</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__NUMBER_OF_PORTS = ABSTRACT_ETHERNET__NUMBER_OF_PORTS;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__SPEED = ABSTRACT_ETHERNET__SPEED;

	/**
	 * The feature id for the '<em><b>Supports Qo S</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__SUPPORTS_QO_S = ABSTRACT_ETHERNET__SUPPORTS_QO_S;

	/**
	 * The feature id for the '<em><b>Mac Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__MAC_ADDRESS = ABSTRACT_ETHERNET_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Cross Over</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__CROSS_OVER = ABSTRACT_ETHERNET_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Rx Queue Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET__RX_QUEUE_SIZE = ABSTRACT_ETHERNET_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_FEATURE_COUNT = ABSTRACT_ETHERNET_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ABSTRACT_ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Ethernet</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_OPERATION_COUNT = ABSTRACT_ETHERNET_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl <em>Ethernet Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getEthernetSwitch()
	 * @generated
	 */
	int ETHERNET_SWITCH = 20;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__INTRINSIC_ID = ABSTRACT_ETHERNET__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__NAME = ABSTRACT_ETHERNET__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__OBJECT_ID = ABSTRACT_ETHERNET__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__EXACTNESS = ABSTRACT_ETHERNET__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__EVENTS = ABSTRACT_ETHERNET__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__PORTS = ABSTRACT_ETHERNET__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__ADDRESS_RANGE = ABSTRACT_ETHERNET__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Auto Negotiate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__AUTO_NEGOTIATE = ABSTRACT_ETHERNET__AUTO_NEGOTIATE;

	/**
	 * The feature id for the '<em><b>Full Duplex</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__FULL_DUPLEX = ABSTRACT_ETHERNET__FULL_DUPLEX;

	/**
	 * The feature id for the '<em><b>Number Of Ports</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__NUMBER_OF_PORTS = ABSTRACT_ETHERNET__NUMBER_OF_PORTS;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__SPEED = ABSTRACT_ETHERNET__SPEED;

	/**
	 * The feature id for the '<em><b>Supports Qo S</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__SUPPORTS_QO_S = ABSTRACT_ETHERNET__SUPPORTS_QO_S;

	/**
	 * The feature id for the '<em><b>Fast Forward</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__FAST_FORWARD = ABSTRACT_ETHERNET_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Log Enabled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH__LOG_ENABLED = ABSTRACT_ETHERNET_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Ethernet Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH_FEATURE_COUNT = ABSTRACT_ETHERNET_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH___IS_COMPATIBLE__ABSTRACTPERIPHERAL = ABSTRACT_ETHERNET___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Ethernet Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ETHERNET_SWITCH_OPERATION_COUNT = ABSTRACT_ETHERNET_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl <em>Flex Ray</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getFlexRay()
	 * @generated
	 */
	int FLEX_RAY = 21;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Cold Starter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__COLD_STARTER = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>PSingle Slot Enabled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PSINGLE_SLOT_ENABLED = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>PKey Slot Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PKEY_SLOT_ID = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>PKey Slot Used For Startup</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP = PERIPHERAL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>PKey Slot Used For Sync</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC = PERIPHERAL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Pd Microtick</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PD_MICROTICK = PERIPHERAL_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>PLatest Tx</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PLATEST_TX = PERIPHERAL_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Pd Listen Time Out</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PD_LISTEN_TIME_OUT = PERIPHERAL_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Pd Max Drift</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PD_MAX_DRIFT = PERIPHERAL_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>PAllow Halt Due To Clock</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK = PERIPHERAL_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>PAllow Passive To Active</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE = PERIPHERAL_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>POffset Correction Out</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__POFFSET_CORRECTION_OUT = PERIPHERAL_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>PRate Correction Out</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY__PRATE_CORRECTION_OUT = PERIPHERAL_FEATURE_COUNT + 12;

	/**
	 * The number of structural features of the '<em>Flex Ray</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 13;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Flex Ray</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl <em>Flex Ray Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getFlexRayBus()
	 * @generated
	 */
	int FLEX_RAY_BUS = 22;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__PORTS = BUS__PORTS;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__SPEED = BUS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Gd Macro Tick</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_MACRO_TICK = BUS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>GMacro Per Cycle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GMACRO_PER_CYCLE = BUS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>GNumber Of Static Slots</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS = BUS_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Gd Nit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_NIT = BUS_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>GPayload Length Static</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC = BUS_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Gd Static Slot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_STATIC_SLOT = BUS_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Gd Dynamic Slot Idle Phase</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE = BUS_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Gd Mini Slot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_MINI_SLOT = BUS_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Gd Action Point Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET = BUS_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Gd Minislot Action Point Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET = BUS_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Gd TSS Transmitter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GD_TSS_TRANSMITTER = BUS_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>GSync Node Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GSYNC_NODE_MAX = BUS_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>GColdstart Attempts</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS = BUS_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>GMax Without Clock Correction Fatal</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL = BUS_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>GMax Without Clock Correction Passive</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE = BUS_FEATURE_COUNT + 15;

	/**
	 * The number of structural features of the '<em>Flex Ray Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS_FEATURE_COUNT = BUS_FEATURE_COUNT + 16;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Flex Ray Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLEX_RAY_BUS_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl <em>Generic IO</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getGenericIO()
	 * @generated
	 */
	int GENERIC_IO = 23;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__TYPE = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Speed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__SPEED = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Bus Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__BUS_WIDTH = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Block Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__BLOCK_SIZE = PERIPHERAL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start IRQ Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__START_IRQ_OFFSET = PERIPHERAL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Emulate DMA</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__EMULATE_DMA = PERIPHERAL_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Pre Overhead</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__PRE_OVERHEAD = PERIPHERAL_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Post Overhead</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__POST_OVERHEAD = PERIPHERAL_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Slave Setup Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO__SLAVE_SETUP_TIME = PERIPHERAL_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Generic IO</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 9;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Generic IO</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_IO_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.IRQImpl <em>IRQ</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.IRQImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getIRQ()
	 * @generated
	 */
	int IRQ = 24;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The number of structural features of the '<em>IRQ</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>IRQ</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IRQ_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.LINImpl <em>LIN</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.LINImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getLIN()
	 * @generated
	 */
	int LIN = 25;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The feature id for the '<em><b>Master</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__MASTER = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Protocol</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN__PROTOCOL = PERIPHERAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>LIN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>LIN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIN_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusImpl <em>Rest Bus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBus()
	 * @generated
	 */
	int REST_BUS = 26;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS__PORTS = BUS__PORTS;

	/**
	 * The number of structural features of the '<em>Rest Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FEATURE_COUNT = BUS_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Rest Bus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusCANImpl <em>Rest Bus CAN</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusCANImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBusCAN()
	 * @generated
	 */
	int REST_BUS_CAN = 27;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN__PORTS = BUS__PORTS;

	/**
	 * The number of structural features of the '<em>Rest Bus CAN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN_FEATURE_COUNT = BUS_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Rest Bus CAN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_CAN_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusFlexRayImpl <em>Rest Bus Flex Ray</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusFlexRayImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBusFlexRay()
	 * @generated
	 */
	int REST_BUS_FLEX_RAY = 28;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__INTRINSIC_ID = BUS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__NAME = BUS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__OBJECT_ID = BUS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__EXACTNESS = BUS__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__EVENTS = BUS__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY__PORTS = BUS__PORTS;

	/**
	 * The number of structural features of the '<em>Rest Bus Flex Ray</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY_FEATURE_COUNT = BUS_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY___IS_COMPATIBLE__ABSTRACTPERIPHERAL = BUS___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Rest Bus Flex Ray</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REST_BUS_FLEX_RAY_OPERATION_COUNT = BUS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.impl.TimerImpl <em>Timer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.impl.TimerImpl
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getTimer()
	 * @generated
	 */
	int TIMER = 29;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__INTRINSIC_ID = PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__NAME = PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__OBJECT_ID = PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__EXACTNESS = PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__EVENTS = PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__PORTS = PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER__ADDRESS_RANGE = PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The number of structural features of the '<em>Timer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_FEATURE_COUNT = PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>Timer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMER_OPERATION_COUNT = PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.AFDXPortDirection <em>AFDX Port Direction</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortDirection
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPortDirection()
	 * @generated
	 */
	int AFDX_PORT_DIRECTION = 30;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.AFDXPortType <em>AFDX Port Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortType
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPortType()
	 * @generated
	 */
	int AFDX_PORT_TYPE = 31;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.peripheral.GenericIOType <em>Generic IO Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.peripheral.GenericIOType
	 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getGenericIOType()
	 * @generated
	 */
	int GENERIC_IO_TYPE = 32;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AbstractPort <em>Abstract Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPort
	 * @generated
	 */
	EClass getAbstractPort();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.peripheral.AbstractPort#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPort#getConnection()
	 * @see #getAbstractPort()
	 * @generated
	 */
	EReference getAbstractPort_Connection();

	/**
	 * Returns the meta object for the '{@link com.inchron.realtime.root.model.peripheral.AbstractPort#isCompatible(com.inchron.realtime.root.model.peripheral.AbstractPort) <em>Is Compatible</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Compatible</em>' operation.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPort#isCompatible(com.inchron.realtime.root.model.peripheral.AbstractPort)
	 * @generated
	 */
	EOperation getAbstractPort__IsCompatible__AbstractPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.BusMasterPort <em>Bus Master Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Master Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.BusMasterPort
	 * @generated
	 */
	EClass getBusMasterPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.BusSlavePort <em>Bus Slave Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Slave Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.BusSlavePort
	 * @generated
	 */
	EClass getBusSlavePort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.InterruptPort <em>Interrupt Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interrupt Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.InterruptPort
	 * @generated
	 */
	EClass getInterruptPort();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.peripheral.InterruptPort#getIsrs <em>Isrs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Isrs</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.InterruptPort#getIsrs()
	 * @see #getInterruptPort()
	 * @generated
	 */
	EReference getInterruptPort_Isrs();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.InputPort <em>Input Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Input Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.InputPort
	 * @generated
	 */
	EClass getInputPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.OutputPort <em>Output Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Output Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.OutputPort
	 * @generated
	 */
	EClass getOutputPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.BiDirPort <em>Bi Dir Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bi Dir Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.BiDirPort
	 * @generated
	 */
	EClass getBiDirPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.PortConnection <em>Port Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Connection</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.PortConnection
	 * @generated
	 */
	EClass getPortConnection();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.peripheral.PortConnection#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Ports</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.PortConnection#getPorts()
	 * @see #getPortConnection()
	 * @generated
	 */
	EReference getPortConnection_Ports();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral <em>Abstract Peripheral</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Peripheral</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPeripheral
	 * @generated
	 */
	EClass getAbstractPeripheral();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getExactness <em>Exactness</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Exactness</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getExactness()
	 * @see #getAbstractPeripheral()
	 * @generated
	 */
	EAttribute getAbstractPeripheral_Exactness();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getEvents()
	 * @see #getAbstractPeripheral()
	 * @generated
	 */
	EReference getAbstractPeripheral_Events();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ports</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getPorts()
	 * @see #getAbstractPeripheral()
	 * @generated
	 */
	EReference getAbstractPeripheral_Ports();

	/**
	 * Returns the meta object for the '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#isCompatible(com.inchron.realtime.root.model.peripheral.AbstractPeripheral) <em>Is Compatible</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Compatible</em>' operation.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractPeripheral#isCompatible(com.inchron.realtime.root.model.peripheral.AbstractPeripheral)
	 * @generated
	 */
	EOperation getAbstractPeripheral__IsCompatible__AbstractPeripheral();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.Peripheral <em>Peripheral</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Peripheral</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Peripheral
	 * @generated
	 */
	EClass getPeripheral();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.peripheral.Peripheral#getAddressRange <em>Address Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Address Range</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Peripheral#getAddressRange()
	 * @see #getPeripheral()
	 * @generated
	 */
	EReference getPeripheral_AddressRange();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.Bus <em>Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Bus
	 * @generated
	 */
	EClass getBus();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet <em>Abstract Ethernet</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Ethernet</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet
	 * @generated
	 */
	EClass getAbstractEthernet();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isAutoNegotiate <em>Auto Negotiate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Auto Negotiate</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet#isAutoNegotiate()
	 * @see #getAbstractEthernet()
	 * @generated
	 */
	EAttribute getAbstractEthernet_AutoNegotiate();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isFullDuplex <em>Full Duplex</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Full Duplex</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet#isFullDuplex()
	 * @see #getAbstractEthernet()
	 * @generated
	 */
	EAttribute getAbstractEthernet_FullDuplex();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getNumberOfPorts <em>Number Of Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Number Of Ports</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet#getNumberOfPorts()
	 * @see #getAbstractEthernet()
	 * @generated
	 */
	EAttribute getAbstractEthernet_NumberOfPorts();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getSpeed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet#getSpeed()
	 * @see #getAbstractEthernet()
	 * @generated
	 */
	EAttribute getAbstractEthernet_Speed();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isSupportsQoS <em>Supports Qo S</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Supports Qo S</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AbstractEthernet#isSupportsQoS()
	 * @see #getAbstractEthernet()
	 * @generated
	 */
	EAttribute getAbstractEthernet_SupportsQoS();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AFDXPort <em>AFDX Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AFDX Port</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPort
	 * @generated
	 */
	EClass getAFDXPort();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPort#getDirection()
	 * @see #getAFDXPort()
	 * @generated
	 */
	EAttribute getAFDXPort_Direction();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPort#getType()
	 * @see #getAFDXPort()
	 * @generated
	 */
	EAttribute getAFDXPort_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getQueueLength <em>Queue Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Queue Length</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPort#getQueueLength()
	 * @see #getAFDXPort()
	 * @generated
	 */
	EAttribute getAFDXPort_QueueLength();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet <em>AFDX Ethernet</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AFDX Ethernet</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet
	 * @generated
	 */
	EClass getAFDXEthernet();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getNetworkId <em>Network Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Network Id</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getNetworkId()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_NetworkId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getEquipmentId <em>Equipment Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Equipment Id</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getEquipmentId()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_EquipmentId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getPartitionId <em>Partition Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Partition Id</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getPartitionId()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_PartitionId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId1 <em>Interface Id1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Interface Id1</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId1()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_InterfaceId1();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac1 <em>Mac1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mac1</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac1()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_Mac1();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId2 <em>Interface Id2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Interface Id2</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId2()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_InterfaceId2();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac2 <em>Mac2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mac2</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac2()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EAttribute getAFDXEthernet_Mac2();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getAfdxPorts <em>Afdx Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Afdx Ports</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXEthernet#getAfdxPorts()
	 * @see #getAFDXEthernet()
	 * @generated
	 */
	EReference getAFDXEthernet_AfdxPorts();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AS5643 <em>AS5643</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AS5643</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643
	 * @generated
	 */
	EClass getAS5643();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#isCC <em>CC</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>CC</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#isCC()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_CC();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#getNodeId <em>Node Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Node Id</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#getNodeId()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_NodeId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#getRank <em>Rank</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rank</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#getRank()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_Rank();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#getTransmissionOffset <em>Transmission Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Transmission Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#getTransmissionOffset()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_TransmissionOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#getReceiveOffset <em>Receive Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Receive Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#getReceiveOffset()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_ReceiveOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#getDatapumpOffset <em>Datapump Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Datapump Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#getDatapumpOffset()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_DatapumpOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643#isMonitorNode <em>Monitor Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Monitor Node</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643#isMonitorNode()
	 * @see #getAS5643()
	 * @generated
	 */
	EAttribute getAS5643_MonitorNode();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.AS5643Bus <em>AS5643 Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AS5643 Bus</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643Bus
	 * @generated
	 */
	EClass getAS5643Bus();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getSpeed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643Bus#getSpeed()
	 * @see #getAS5643Bus()
	 * @generated
	 */
	EAttribute getAS5643Bus_Speed();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getFrameLength <em>Frame Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Frame Length</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AS5643Bus#getFrameLength()
	 * @see #getAS5643Bus()
	 * @generated
	 */
	EReference getAS5643Bus_FrameLength();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.CAN <em>CAN</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CAN</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CAN
	 * @generated
	 */
	EClass getCAN();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.CAN#getBufferStrategy <em>Buffer Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buffer Strategy</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CAN#getBufferStrategy()
	 * @see #getCAN()
	 * @generated
	 */
	EAttribute getCAN_BufferStrategy();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.CAN#getNumberOfBuffers <em>Number Of Buffers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Number Of Buffers</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CAN#getNumberOfBuffers()
	 * @see #getCAN()
	 * @generated
	 */
	EAttribute getCAN_NumberOfBuffers();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.CANBus <em>CAN Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CAN Bus</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CANBus
	 * @generated
	 */
	EClass getCANBus();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.CANBus#isLogEnabled <em>Log Enabled</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Enabled</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CANBus#isLogEnabled()
	 * @see #getCANBus()
	 * @generated
	 */
	EAttribute getCANBus_LogEnabled();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.CANBus#getSpeed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CANBus#getSpeed()
	 * @see #getCANBus()
	 * @generated
	 */
	EAttribute getCANBus_Speed();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.CANBus#getDataSpeed <em>Data Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.CANBus#getDataSpeed()
	 * @see #getCANBus()
	 * @generated
	 */
	EAttribute getCANBus_DataSpeed();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.Console <em>Console</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Console</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Console
	 * @generated
	 */
	EClass getConsole();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.Ethernet <em>Ethernet</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ethernet</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Ethernet
	 * @generated
	 */
	EClass getEthernet();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.Ethernet#getMacAddress <em>Mac Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mac Address</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Ethernet#getMacAddress()
	 * @see #getEthernet()
	 * @generated
	 */
	EAttribute getEthernet_MacAddress();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.Ethernet#isCrossOver <em>Cross Over</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cross Over</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Ethernet#isCrossOver()
	 * @see #getEthernet()
	 * @generated
	 */
	EAttribute getEthernet_CrossOver();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.Ethernet#getRxQueueSize <em>Rx Queue Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rx Queue Size</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Ethernet#getRxQueueSize()
	 * @see #getEthernet()
	 * @generated
	 */
	EAttribute getEthernet_RxQueueSize();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch <em>Ethernet Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ethernet Switch</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.EthernetSwitch
	 * @generated
	 */
	EClass getEthernetSwitch();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isFastForward <em>Fast Forward</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fast Forward</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.EthernetSwitch#isFastForward()
	 * @see #getEthernetSwitch()
	 * @generated
	 */
	EAttribute getEthernetSwitch_FastForward();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isLogEnabled <em>Log Enabled</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Enabled</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.EthernetSwitch#isLogEnabled()
	 * @see #getEthernetSwitch()
	 * @generated
	 */
	EAttribute getEthernetSwitch_LogEnabled();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.FlexRay <em>Flex Ray</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flex Ray</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay
	 * @generated
	 */
	EClass getFlexRay();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isColdStarter <em>Cold Starter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cold Starter</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#isColdStarter()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_ColdStarter();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPSingleSlotEnabled <em>PSingle Slot Enabled</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PSingle Slot Enabled</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#isPSingleSlotEnabled()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PSingleSlotEnabled();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPKeySlotId <em>PKey Slot Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PKey Slot Id</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPKeySlotId()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PKeySlotId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForStartup <em>PKey Slot Used For Startup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PKey Slot Used For Startup</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForStartup()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PKeySlotUsedForStartup();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForSync <em>PKey Slot Used For Sync</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PKey Slot Used For Sync</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForSync()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PKeySlotUsedForSync();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMicrotick <em>Pd Microtick</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pd Microtick</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPdMicrotick()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PdMicrotick();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPLatestTx <em>PLatest Tx</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PLatest Tx</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPLatestTx()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PLatestTx();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdListenTimeOut <em>Pd Listen Time Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pd Listen Time Out</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPdListenTimeOut()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PdListenTimeOut();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMaxDrift <em>Pd Max Drift</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pd Max Drift</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPdMaxDrift()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PdMaxDrift();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPAllowHaltDueToClock <em>PAllow Halt Due To Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PAllow Halt Due To Clock</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#isPAllowHaltDueToClock()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PAllowHaltDueToClock();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPAllowPassiveToActive <em>PAllow Passive To Active</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PAllow Passive To Active</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPAllowPassiveToActive()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PAllowPassiveToActive();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPOffsetCorrectionOut <em>POffset Correction Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>POffset Correction Out</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPOffsetCorrectionOut()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_POffsetCorrectionOut();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPRateCorrectionOut <em>PRate Correction Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>PRate Correction Out</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRay#getPRateCorrectionOut()
	 * @see #getFlexRay()
	 * @generated
	 */
	EAttribute getFlexRay_PRateCorrectionOut();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus <em>Flex Ray Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flex Ray Bus</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus
	 * @generated
	 */
	EClass getFlexRayBus();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getSpeed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getSpeed()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_Speed();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMacroTick <em>Gd Macro Tick</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Macro Tick</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMacroTick()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdMacroTick();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMacroPerCycle <em>GMacro Per Cycle</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GMacro Per Cycle</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMacroPerCycle()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GMacroPerCycle();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGNumberOfStaticSlots <em>GNumber Of Static Slots</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GNumber Of Static Slots</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGNumberOfStaticSlots()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GNumberOfStaticSlots();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdNit <em>Gd Nit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Nit</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdNit()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdNit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGPayloadLengthStatic <em>GPayload Length Static</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GPayload Length Static</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGPayloadLengthStatic()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GPayloadLengthStatic();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdStaticSlot <em>Gd Static Slot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Static Slot</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdStaticSlot()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdStaticSlot();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdDynamicSlotIdlePhase <em>Gd Dynamic Slot Idle Phase</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Dynamic Slot Idle Phase</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdDynamicSlotIdlePhase()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdDynamicSlotIdlePhase();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMiniSlot <em>Gd Mini Slot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Mini Slot</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMiniSlot()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdMiniSlot();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdActionPointOffset <em>Gd Action Point Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Action Point Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdActionPointOffset()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdActionPointOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMinislotActionPointOffset <em>Gd Minislot Action Point Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd Minislot Action Point Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMinislotActionPointOffset()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdMinislotActionPointOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdTSSTransmitter <em>Gd TSS Transmitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Gd TSS Transmitter</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdTSSTransmitter()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GdTSSTransmitter();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGSyncNodeMax <em>GSync Node Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GSync Node Max</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGSyncNodeMax()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GSyncNodeMax();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGColdstartAttempts <em>GColdstart Attempts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GColdstart Attempts</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGColdstartAttempts()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GColdstartAttempts();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionFatal <em>GMax Without Clock Correction Fatal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GMax Without Clock Correction Fatal</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionFatal()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GMaxWithoutClockCorrectionFatal();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionPassive <em>GMax Without Clock Correction Passive</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>GMax Without Clock Correction Passive</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionPassive()
	 * @see #getFlexRayBus()
	 * @generated
	 */
	EAttribute getFlexRayBus_GMaxWithoutClockCorrectionPassive();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.GenericIO <em>Generic IO</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic IO</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO
	 * @generated
	 */
	EClass getGenericIO();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getType()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSpeed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Speed</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getSpeed()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_Speed();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBusWidth <em>Bus Width</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bus Width</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getBusWidth()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_BusWidth();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBlockSize <em>Block Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Block Size</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getBlockSize()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_BlockSize();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getStartIRQOffset <em>Start IRQ Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start IRQ Offset</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getStartIRQOffset()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_StartIRQOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.GenericIO#isEmulateDMA <em>Emulate DMA</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Emulate DMA</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#isEmulateDMA()
	 * @see #getGenericIO()
	 * @generated
	 */
	EAttribute getGenericIO_EmulateDMA();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPreOverhead <em>Pre Overhead</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pre Overhead</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getPreOverhead()
	 * @see #getGenericIO()
	 * @generated
	 */
	EReference getGenericIO_PreOverhead();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPostOverhead <em>Post Overhead</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Post Overhead</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getPostOverhead()
	 * @see #getGenericIO()
	 * @generated
	 */
	EReference getGenericIO_PostOverhead();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSlaveSetupTime <em>Slave Setup Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Slave Setup Time</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIO#getSlaveSetupTime()
	 * @see #getGenericIO()
	 * @generated
	 */
	EReference getGenericIO_SlaveSetupTime();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.IRQ <em>IRQ</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IRQ</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.IRQ
	 * @generated
	 */
	EClass getIRQ();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.LIN <em>LIN</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LIN</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.LIN
	 * @generated
	 */
	EClass getLIN();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.LIN#isMaster <em>Master</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Master</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.LIN#isMaster()
	 * @see #getLIN()
	 * @generated
	 */
	EAttribute getLIN_Master();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.peripheral.LIN#getProtocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Protocol</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.LIN#getProtocol()
	 * @see #getLIN()
	 * @generated
	 */
	EAttribute getLIN_Protocol();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.RestBus <em>Rest Bus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rest Bus</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.RestBus
	 * @generated
	 */
	EClass getRestBus();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.RestBusCAN <em>Rest Bus CAN</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rest Bus CAN</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.RestBusCAN
	 * @generated
	 */
	EClass getRestBusCAN();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.RestBusFlexRay <em>Rest Bus Flex Ray</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rest Bus Flex Ray</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.RestBusFlexRay
	 * @generated
	 */
	EClass getRestBusFlexRay();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.peripheral.Timer <em>Timer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Timer</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.Timer
	 * @generated
	 */
	EClass getTimer();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.peripheral.AFDXPortDirection <em>AFDX Port Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>AFDX Port Direction</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortDirection
	 * @generated
	 */
	EEnum getAFDXPortDirection();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.peripheral.AFDXPortType <em>AFDX Port Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>AFDX Port Type</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortType
	 * @generated
	 */
	EEnum getAFDXPortType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.peripheral.GenericIOType <em>Generic IO Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Generic IO Type</em>'.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIOType
	 * @generated
	 */
	EEnum getGenericIOType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PeripheralFactory getPeripheralFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPortImpl <em>Abstract Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractPort()
		 * @generated
		 */
		EClass ABSTRACT_PORT = eINSTANCE.getAbstractPort();

		/**
		 * The meta object literal for the '<em><b>Connection</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_PORT__CONNECTION = eINSTANCE.getAbstractPort_Connection();

		/**
		 * The meta object literal for the '<em><b>Is Compatible</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT = eINSTANCE.getAbstractPort__IsCompatible__AbstractPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusMasterPortImpl <em>Bus Master Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.BusMasterPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBusMasterPort()
		 * @generated
		 */
		EClass BUS_MASTER_PORT = eINSTANCE.getBusMasterPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusSlavePortImpl <em>Bus Slave Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.BusSlavePortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBusSlavePort()
		 * @generated
		 */
		EClass BUS_SLAVE_PORT = eINSTANCE.getBusSlavePort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.InterruptPortImpl <em>Interrupt Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.InterruptPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getInterruptPort()
		 * @generated
		 */
		EClass INTERRUPT_PORT = eINSTANCE.getInterruptPort();

		/**
		 * The meta object literal for the '<em><b>Isrs</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERRUPT_PORT__ISRS = eINSTANCE.getInterruptPort_Isrs();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.InputPortImpl <em>Input Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.InputPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getInputPort()
		 * @generated
		 */
		EClass INPUT_PORT = eINSTANCE.getInputPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.OutputPortImpl <em>Output Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.OutputPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getOutputPort()
		 * @generated
		 */
		EClass OUTPUT_PORT = eINSTANCE.getOutputPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.BiDirPortImpl <em>Bi Dir Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.BiDirPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBiDirPort()
		 * @generated
		 */
		EClass BI_DIR_PORT = eINSTANCE.getBiDirPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.PortConnectionImpl <em>Port Connection</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.PortConnectionImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getPortConnection()
		 * @generated
		 */
		EClass PORT_CONNECTION = eINSTANCE.getPortConnection();

		/**
		 * The meta object literal for the '<em><b>Ports</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT_CONNECTION__PORTS = eINSTANCE.getPortConnection_Ports();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl <em>Abstract Peripheral</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractPeripheral()
		 * @generated
		 */
		EClass ABSTRACT_PERIPHERAL = eINSTANCE.getAbstractPeripheral();

		/**
		 * The meta object literal for the '<em><b>Exactness</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_PERIPHERAL__EXACTNESS = eINSTANCE.getAbstractPeripheral_Exactness();

		/**
		 * The meta object literal for the '<em><b>Events</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_PERIPHERAL__EVENTS = eINSTANCE.getAbstractPeripheral_Events();

		/**
		 * The meta object literal for the '<em><b>Ports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_PERIPHERAL__PORTS = eINSTANCE.getAbstractPeripheral_Ports();

		/**
		 * The meta object literal for the '<em><b>Is Compatible</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ABSTRACT_PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL = eINSTANCE.getAbstractPeripheral__IsCompatible__AbstractPeripheral();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.PeripheralImpl <em>Peripheral</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getPeripheral()
		 * @generated
		 */
		EClass PERIPHERAL = eINSTANCE.getPeripheral();

		/**
		 * The meta object literal for the '<em><b>Address Range</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERIPHERAL__ADDRESS_RANGE = eINSTANCE.getPeripheral_AddressRange();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.BusImpl <em>Bus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.BusImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getBus()
		 * @generated
		 */
		EClass BUS = eINSTANCE.getBus();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl <em>Abstract Ethernet</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAbstractEthernet()
		 * @generated
		 */
		EClass ABSTRACT_ETHERNET = eINSTANCE.getAbstractEthernet();

		/**
		 * The meta object literal for the '<em><b>Auto Negotiate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_ETHERNET__AUTO_NEGOTIATE = eINSTANCE.getAbstractEthernet_AutoNegotiate();

		/**
		 * The meta object literal for the '<em><b>Full Duplex</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_ETHERNET__FULL_DUPLEX = eINSTANCE.getAbstractEthernet_FullDuplex();

		/**
		 * The meta object literal for the '<em><b>Number Of Ports</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_ETHERNET__NUMBER_OF_PORTS = eINSTANCE.getAbstractEthernet_NumberOfPorts();

		/**
		 * The meta object literal for the '<em><b>Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_ETHERNET__SPEED = eINSTANCE.getAbstractEthernet_Speed();

		/**
		 * The meta object literal for the '<em><b>Supports Qo S</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_ETHERNET__SUPPORTS_QO_S = eINSTANCE.getAbstractEthernet_SupportsQoS();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AFDXPortImpl <em>AFDX Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AFDXPortImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPort()
		 * @generated
		 */
		EClass AFDX_PORT = eINSTANCE.getAFDXPort();

		/**
		 * The meta object literal for the '<em><b>Direction</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_PORT__DIRECTION = eINSTANCE.getAFDXPort_Direction();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_PORT__TYPE = eINSTANCE.getAFDXPort_Type();

		/**
		 * The meta object literal for the '<em><b>Queue Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_PORT__QUEUE_LENGTH = eINSTANCE.getAFDXPort_QueueLength();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl <em>AFDX Ethernet</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXEthernet()
		 * @generated
		 */
		EClass AFDX_ETHERNET = eINSTANCE.getAFDXEthernet();

		/**
		 * The meta object literal for the '<em><b>Network Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__NETWORK_ID = eINSTANCE.getAFDXEthernet_NetworkId();

		/**
		 * The meta object literal for the '<em><b>Equipment Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__EQUIPMENT_ID = eINSTANCE.getAFDXEthernet_EquipmentId();

		/**
		 * The meta object literal for the '<em><b>Partition Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__PARTITION_ID = eINSTANCE.getAFDXEthernet_PartitionId();

		/**
		 * The meta object literal for the '<em><b>Interface Id1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__INTERFACE_ID1 = eINSTANCE.getAFDXEthernet_InterfaceId1();

		/**
		 * The meta object literal for the '<em><b>Mac1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__MAC1 = eINSTANCE.getAFDXEthernet_Mac1();

		/**
		 * The meta object literal for the '<em><b>Interface Id2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__INTERFACE_ID2 = eINSTANCE.getAFDXEthernet_InterfaceId2();

		/**
		 * The meta object literal for the '<em><b>Mac2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AFDX_ETHERNET__MAC2 = eINSTANCE.getAFDXEthernet_Mac2();

		/**
		 * The meta object literal for the '<em><b>Afdx Ports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AFDX_ETHERNET__AFDX_PORTS = eINSTANCE.getAFDXEthernet_AfdxPorts();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl <em>AS5643</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AS5643Impl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAS5643()
		 * @generated
		 */
		EClass AS5643 = eINSTANCE.getAS5643();

		/**
		 * The meta object literal for the '<em><b>CC</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__CC = eINSTANCE.getAS5643_CC();

		/**
		 * The meta object literal for the '<em><b>Node Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__NODE_ID = eINSTANCE.getAS5643_NodeId();

		/**
		 * The meta object literal for the '<em><b>Rank</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__RANK = eINSTANCE.getAS5643_Rank();

		/**
		 * The meta object literal for the '<em><b>Transmission Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__TRANSMISSION_OFFSET = eINSTANCE.getAS5643_TransmissionOffset();

		/**
		 * The meta object literal for the '<em><b>Receive Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__RECEIVE_OFFSET = eINSTANCE.getAS5643_ReceiveOffset();

		/**
		 * The meta object literal for the '<em><b>Datapump Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__DATAPUMP_OFFSET = eINSTANCE.getAS5643_DatapumpOffset();

		/**
		 * The meta object literal for the '<em><b>Monitor Node</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643__MONITOR_NODE = eINSTANCE.getAS5643_MonitorNode();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl <em>AS5643 Bus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAS5643Bus()
		 * @generated
		 */
		EClass AS5643_BUS = eINSTANCE.getAS5643Bus();

		/**
		 * The meta object literal for the '<em><b>Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AS5643_BUS__SPEED = eINSTANCE.getAS5643Bus_Speed();

		/**
		 * The meta object literal for the '<em><b>Frame Length</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AS5643_BUS__FRAME_LENGTH = eINSTANCE.getAS5643Bus_FrameLength();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.CANImpl <em>CAN</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.CANImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getCAN()
		 * @generated
		 */
		EClass CAN = eINSTANCE.getCAN();

		/**
		 * The meta object literal for the '<em><b>Buffer Strategy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAN__BUFFER_STRATEGY = eINSTANCE.getCAN_BufferStrategy();

		/**
		 * The meta object literal for the '<em><b>Number Of Buffers</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAN__NUMBER_OF_BUFFERS = eINSTANCE.getCAN_NumberOfBuffers();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.CANBusImpl <em>CAN Bus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.CANBusImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getCANBus()
		 * @generated
		 */
		EClass CAN_BUS = eINSTANCE.getCANBus();

		/**
		 * The meta object literal for the '<em><b>Log Enabled</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAN_BUS__LOG_ENABLED = eINSTANCE.getCANBus_LogEnabled();

		/**
		 * The meta object literal for the '<em><b>Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAN_BUS__SPEED = eINSTANCE.getCANBus_Speed();

		/**
		 * The meta object literal for the '<em><b>Data Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAN_BUS__DATA_SPEED = eINSTANCE.getCANBus_DataSpeed();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.ConsoleImpl <em>Console</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.ConsoleImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getConsole()
		 * @generated
		 */
		EClass CONSOLE = eINSTANCE.getConsole();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.EthernetImpl <em>Ethernet</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.EthernetImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getEthernet()
		 * @generated
		 */
		EClass ETHERNET = eINSTANCE.getEthernet();

		/**
		 * The meta object literal for the '<em><b>Mac Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ETHERNET__MAC_ADDRESS = eINSTANCE.getEthernet_MacAddress();

		/**
		 * The meta object literal for the '<em><b>Cross Over</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ETHERNET__CROSS_OVER = eINSTANCE.getEthernet_CrossOver();

		/**
		 * The meta object literal for the '<em><b>Rx Queue Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ETHERNET__RX_QUEUE_SIZE = eINSTANCE.getEthernet_RxQueueSize();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl <em>Ethernet Switch</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.EthernetSwitchImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getEthernetSwitch()
		 * @generated
		 */
		EClass ETHERNET_SWITCH = eINSTANCE.getEthernetSwitch();

		/**
		 * The meta object literal for the '<em><b>Fast Forward</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ETHERNET_SWITCH__FAST_FORWARD = eINSTANCE.getEthernetSwitch_FastForward();

		/**
		 * The meta object literal for the '<em><b>Log Enabled</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ETHERNET_SWITCH__LOG_ENABLED = eINSTANCE.getEthernetSwitch_LogEnabled();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl <em>Flex Ray</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.FlexRayImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getFlexRay()
		 * @generated
		 */
		EClass FLEX_RAY = eINSTANCE.getFlexRay();

		/**
		 * The meta object literal for the '<em><b>Cold Starter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__COLD_STARTER = eINSTANCE.getFlexRay_ColdStarter();

		/**
		 * The meta object literal for the '<em><b>PSingle Slot Enabled</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PSINGLE_SLOT_ENABLED = eINSTANCE.getFlexRay_PSingleSlotEnabled();

		/**
		 * The meta object literal for the '<em><b>PKey Slot Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PKEY_SLOT_ID = eINSTANCE.getFlexRay_PKeySlotId();

		/**
		 * The meta object literal for the '<em><b>PKey Slot Used For Startup</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PKEY_SLOT_USED_FOR_STARTUP = eINSTANCE.getFlexRay_PKeySlotUsedForStartup();

		/**
		 * The meta object literal for the '<em><b>PKey Slot Used For Sync</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PKEY_SLOT_USED_FOR_SYNC = eINSTANCE.getFlexRay_PKeySlotUsedForSync();

		/**
		 * The meta object literal for the '<em><b>Pd Microtick</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PD_MICROTICK = eINSTANCE.getFlexRay_PdMicrotick();

		/**
		 * The meta object literal for the '<em><b>PLatest Tx</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PLATEST_TX = eINSTANCE.getFlexRay_PLatestTx();

		/**
		 * The meta object literal for the '<em><b>Pd Listen Time Out</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PD_LISTEN_TIME_OUT = eINSTANCE.getFlexRay_PdListenTimeOut();

		/**
		 * The meta object literal for the '<em><b>Pd Max Drift</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PD_MAX_DRIFT = eINSTANCE.getFlexRay_PdMaxDrift();

		/**
		 * The meta object literal for the '<em><b>PAllow Halt Due To Clock</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PALLOW_HALT_DUE_TO_CLOCK = eINSTANCE.getFlexRay_PAllowHaltDueToClock();

		/**
		 * The meta object literal for the '<em><b>PAllow Passive To Active</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PALLOW_PASSIVE_TO_ACTIVE = eINSTANCE.getFlexRay_PAllowPassiveToActive();

		/**
		 * The meta object literal for the '<em><b>POffset Correction Out</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__POFFSET_CORRECTION_OUT = eINSTANCE.getFlexRay_POffsetCorrectionOut();

		/**
		 * The meta object literal for the '<em><b>PRate Correction Out</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY__PRATE_CORRECTION_OUT = eINSTANCE.getFlexRay_PRateCorrectionOut();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl <em>Flex Ray Bus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getFlexRayBus()
		 * @generated
		 */
		EClass FLEX_RAY_BUS = eINSTANCE.getFlexRayBus();

		/**
		 * The meta object literal for the '<em><b>Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__SPEED = eINSTANCE.getFlexRayBus_Speed();

		/**
		 * The meta object literal for the '<em><b>Gd Macro Tick</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_MACRO_TICK = eINSTANCE.getFlexRayBus_GdMacroTick();

		/**
		 * The meta object literal for the '<em><b>GMacro Per Cycle</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GMACRO_PER_CYCLE = eINSTANCE.getFlexRayBus_GMacroPerCycle();

		/**
		 * The meta object literal for the '<em><b>GNumber Of Static Slots</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS = eINSTANCE.getFlexRayBus_GNumberOfStaticSlots();

		/**
		 * The meta object literal for the '<em><b>Gd Nit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_NIT = eINSTANCE.getFlexRayBus_GdNit();

		/**
		 * The meta object literal for the '<em><b>GPayload Length Static</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC = eINSTANCE.getFlexRayBus_GPayloadLengthStatic();

		/**
		 * The meta object literal for the '<em><b>Gd Static Slot</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_STATIC_SLOT = eINSTANCE.getFlexRayBus_GdStaticSlot();

		/**
		 * The meta object literal for the '<em><b>Gd Dynamic Slot Idle Phase</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE = eINSTANCE.getFlexRayBus_GdDynamicSlotIdlePhase();

		/**
		 * The meta object literal for the '<em><b>Gd Mini Slot</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_MINI_SLOT = eINSTANCE.getFlexRayBus_GdMiniSlot();

		/**
		 * The meta object literal for the '<em><b>Gd Action Point Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET = eINSTANCE.getFlexRayBus_GdActionPointOffset();

		/**
		 * The meta object literal for the '<em><b>Gd Minislot Action Point Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET = eINSTANCE.getFlexRayBus_GdMinislotActionPointOffset();

		/**
		 * The meta object literal for the '<em><b>Gd TSS Transmitter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GD_TSS_TRANSMITTER = eINSTANCE.getFlexRayBus_GdTSSTransmitter();

		/**
		 * The meta object literal for the '<em><b>GSync Node Max</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GSYNC_NODE_MAX = eINSTANCE.getFlexRayBus_GSyncNodeMax();

		/**
		 * The meta object literal for the '<em><b>GColdstart Attempts</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS = eINSTANCE.getFlexRayBus_GColdstartAttempts();

		/**
		 * The meta object literal for the '<em><b>GMax Without Clock Correction Fatal</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL = eINSTANCE.getFlexRayBus_GMaxWithoutClockCorrectionFatal();

		/**
		 * The meta object literal for the '<em><b>GMax Without Clock Correction Passive</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE = eINSTANCE.getFlexRayBus_GMaxWithoutClockCorrectionPassive();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl <em>Generic IO</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getGenericIO()
		 * @generated
		 */
		EClass GENERIC_IO = eINSTANCE.getGenericIO();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__TYPE = eINSTANCE.getGenericIO_Type();

		/**
		 * The meta object literal for the '<em><b>Speed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__SPEED = eINSTANCE.getGenericIO_Speed();

		/**
		 * The meta object literal for the '<em><b>Bus Width</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__BUS_WIDTH = eINSTANCE.getGenericIO_BusWidth();

		/**
		 * The meta object literal for the '<em><b>Block Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__BLOCK_SIZE = eINSTANCE.getGenericIO_BlockSize();

		/**
		 * The meta object literal for the '<em><b>Start IRQ Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__START_IRQ_OFFSET = eINSTANCE.getGenericIO_StartIRQOffset();

		/**
		 * The meta object literal for the '<em><b>Emulate DMA</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_IO__EMULATE_DMA = eINSTANCE.getGenericIO_EmulateDMA();

		/**
		 * The meta object literal for the '<em><b>Pre Overhead</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_IO__PRE_OVERHEAD = eINSTANCE.getGenericIO_PreOverhead();

		/**
		 * The meta object literal for the '<em><b>Post Overhead</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_IO__POST_OVERHEAD = eINSTANCE.getGenericIO_PostOverhead();

		/**
		 * The meta object literal for the '<em><b>Slave Setup Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_IO__SLAVE_SETUP_TIME = eINSTANCE.getGenericIO_SlaveSetupTime();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.IRQImpl <em>IRQ</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.IRQImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getIRQ()
		 * @generated
		 */
		EClass IRQ = eINSTANCE.getIRQ();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.LINImpl <em>LIN</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.LINImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getLIN()
		 * @generated
		 */
		EClass LIN = eINSTANCE.getLIN();

		/**
		 * The meta object literal for the '<em><b>Master</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LIN__MASTER = eINSTANCE.getLIN_Master();

		/**
		 * The meta object literal for the '<em><b>Protocol</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LIN__PROTOCOL = eINSTANCE.getLIN_Protocol();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusImpl <em>Rest Bus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBus()
		 * @generated
		 */
		EClass REST_BUS = eINSTANCE.getRestBus();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusCANImpl <em>Rest Bus CAN</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusCANImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBusCAN()
		 * @generated
		 */
		EClass REST_BUS_CAN = eINSTANCE.getRestBusCAN();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.RestBusFlexRayImpl <em>Rest Bus Flex Ray</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.RestBusFlexRayImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getRestBusFlexRay()
		 * @generated
		 */
		EClass REST_BUS_FLEX_RAY = eINSTANCE.getRestBusFlexRay();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.impl.TimerImpl <em>Timer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.impl.TimerImpl
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getTimer()
		 * @generated
		 */
		EClass TIMER = eINSTANCE.getTimer();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.AFDXPortDirection <em>AFDX Port Direction</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.AFDXPortDirection
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPortDirection()
		 * @generated
		 */
		EEnum AFDX_PORT_DIRECTION = eINSTANCE.getAFDXPortDirection();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.AFDXPortType <em>AFDX Port Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.AFDXPortType
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getAFDXPortType()
		 * @generated
		 */
		EEnum AFDX_PORT_TYPE = eINSTANCE.getAFDXPortType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.peripheral.GenericIOType <em>Generic IO Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.peripheral.GenericIOType
		 * @see com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl#getGenericIOType()
		 * @generated
		 */
		EEnum GENERIC_IO_TYPE = eINSTANCE.getGenericIOType();

	}

} //PeripheralPackage
